
DROP TABLE IF EXISTS `XHP_TBL_PREFIXblog_comments`;
CREATE TABLE `XHP_TBL_PREFIXblog_comments` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `date_posted` datetime NOT NULL default '0000-00-00 00:00:00',
  `comment` text NOT NULL,
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXblog_posts`;
CREATE TABLE `XHP_TBL_PREFIXblog_posts` (
  `post_id` bigint(20) NOT NULL auto_increment,
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `box_id` int(11) NOT NULL default '0',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `poster_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`post_id`)
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXblog_settings`;
CREATE TABLE `XHP_TBL_PREFIXblog_settings` (
  `box_id` int(11) default NULL,
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `image_url` text NOT NULL,
  `allow_comments` smallint(6) NOT NULL default '1'
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXblogroll_feeds`;
CREATE TABLE `XHP_TBL_PREFIXblogroll_feeds` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `box_id` int(11) NOT NULL default '0',
  `url` text NOT NULL,
  `last_refresh` datetime NOT NULL default '0000-00-00 00:00:00',
  `refresh_interval` int(11) NOT NULL default '600',
  `title` varchar(255) NOT NULL default '',
  `link` text NOT NULL,
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXblogroll_items`;
CREATE TABLE `XHP_TBL_PREFIXblogroll_items` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `feed_id` bigint(20) unsigned NOT NULL default '0',
  `item_object` text NOT NULL,
  `item_md5` varchar(255) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `date_timestamp` bigint(20) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `link` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `item_md5` (`item_md5`)
);

DROP TABLE IF EXISTS `XHP_TBL_PREFIXblogroll_settings`;
CREATE TABLE `XHP_TBL_PREFIXblogroll_settings` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `box_id` int(11) NOT NULL default '0',
  `number_of_items` int(11) NOT NULL default '0',
  `max_characters` int(11) NOT NULL default '500',
  `columns_no` int(11) NOT NULL default '1',
  `display_title` tinyint(4) NOT NULL default '1',
  `display_date` tinyint(4) NOT NULL default '1',
  `display_description` tinyint(4) NOT NULL default '1',
  `display_source` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXboxes`;
CREATE TABLE `XHP_TBL_PREFIXboxes` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `page_id` int(11) NOT NULL default '0',
  `module_id` varchar(255) NOT NULL default '',
  `module_order` int(11) NOT NULL default '1',
  `main_module` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

LOCK TABLES `XHP_TBL_PREFIXboxes` WRITE;
INSERT INTO `XHP_TBL_PREFIXboxes` VALUES (29,'MAIN_CONTENT',0,'users',1,0),(48,'RIGHT_CONTENT',2,'content',1,0),(47,'MAIN_CONTENT',2,'content',1,0);
UNLOCK TABLES;


DROP TABLE IF EXISTS `XHP_TBL_PREFIXconfig`;
CREATE TABLE `XHP_TBL_PREFIXconfig` (
  `variable` varchar(255) default NULL,
  `value` varchar(255) default NULL
);

LOCK TABLES `XHP_TBL_PREFIXconfig` WRITE;
INSERT INTO `XHP_TBL_PREFIXconfig` VALUES ('PAGE_TITLE','XHP CMS'),('PAGE_URL','http://localhost/xhp/'),('PAGE_DESCRIPTION','XHP CMS - eXpandable Home Page is an easy to install, easy to use, easy to expand content management system (CMS) written in PHP and using MySQL as the database engine. It includes blog, image gallery, WYSIWYG content editor, aggregator , guestbook and it'),('THEME','xhp'),('LANGUAGE','english');
UNLOCK TABLES;


DROP TABLE IF EXISTS `XHP_TBL_PREFIXcontent`;
CREATE TABLE `XHP_TBL_PREFIXcontent` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `content` text,
  `type` smallint(6) NOT NULL default '0',
  `box_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

LOCK TABLES `XHP_TBL_PREFIXcontent` WRITE;
INSERT INTO `XHP_TBL_PREFIXcontent` VALUES (1,'Content','test &quot; test<br />\r\n',0,32),(2,'Content','\r\n\r\n\r\nXHP CMS - eXpandable Home Page is an easy to install, easy to use, easy to expand content management system (CMS) written in PHP and using MySQL as the database engine. It includes blog, image gallery, WYSIWYG content editor, aggregator , guestbook and it provides an API for contributed modules. <br /><br />XHP CMS runs on both PHP 4 and PHP 5. <br /><br />XHP CMS has great support for templates and internationalization. <br /><br />XHP CMS is open source software, licensed under the GNU GPL.<br /><br />It\'s development has been started in 2003 by Laurentiu &quot;Lars&quot; Matei in Bucharest, Romania. Although started as a personal home-page oriented CMS, XHP is today suitable for a much wider range of web applications, including complex enterprise portals. <br /><br />Separate goodies for personal home pages can be found but putting them all together is a pain for regular users and time consuming for computer experts that only want to set-up a simple personal home page. Once this simple home page is up and working, you can start expanding it to transform it into a complex portal.<br /><br />XHP CMS templates, modules and language packages can be found at <a href=\"http://xhp.targetit.ro/\">xhp.targetit.ro</a>.<br /><br />XHP CMS contributors:<br /><br />     Laurentiu &quot;Lars&quot; Matei <laurentiu.matei>, Bucharest, Romania - project admin, coding, documentation, design<br /><br />Adrian Rapa <adrian.rapa>, Bucharest, Romania - coding<br /><br />Nathanael Reveal, Nashville, TN, USA - coding<br /><br />Tim Ellacott, Canada - coding\r\n   <br /><br />Bogdan Grigore, Bucharest, Romania - design<br /><br />Bureau Cornavin, Strasbourg, France - translation<br /><br />Uwe Wilske, Germany - translation\r\n   <br /><br />Iqbal &quot;ReZa&quot; Fazlurrahman, Indonesia - translation<br /><br />A. Attila - translation<br /><br />Davor Guttierrez, Slovenia - translation</adrian.rapa></laurentiu.matei>',1,47),(3,'Content','\r\n\r\n<font size=\"4\"><span style=\"font-weight: bold;\">\r\n\r\n\r\nSponsors</span></font><br /><br /><a href=\"http://www.targetit.ro/\"><img src=\"http://localhost/xhp/imagemanager/targetit_logo.png\" /></a><br /><a href=\"http://www.targetit.ro/\">Target: IT - new Software()</a><br /><br /><br /><a href=\"http://www.bureau-cornavin.com/\"><img src=\"http://localhost/xhp/imagemanager/logo_cornavin.png\" /></a><br /><a href=\"http://www.bureau-cornavin.com/\">Bureau Cornavin - The translation and documentation experts</a>',1,48);
UNLOCK TABLES;

DROP TABLE IF EXISTS `XHP_TBL_PREFIXgallery_albums`;
CREATE TABLE `XHP_TBL_PREFIXgallery_albums` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `description` text,
  `thumbnail_columns` tinyint(4) NOT NULL default '1',
  `thumbnail_id` int(10) unsigned NOT NULL default '0',
  `box_id` int(11) NOT NULL default '0',
  `default_album` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `XHP_TBL_PREFIXgallery_pictures`;
CREATE TABLE `XHP_TBL_PREFIXgallery_pictures` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `album_id` int(10) unsigned default NULL,
  `name` varchar(255) default NULL,
  `description` text,
  `date_taken` date default NULL,
  `display_order` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `XHP_TBL_PREFIXguest`;
CREATE TABLE `XHP_TBL_PREFIXguest` (
  `id` int(11) NOT NULL auto_increment,
  `comment` text NOT NULL,
  `name` varchar(255) NOT NULL default '',
  `date_posted` date NOT NULL default '0000-00-00',
  `box_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `XHP_TBL_PREFIXlinks`;
CREATE TABLE `XHP_TBL_PREFIXlinks` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `url` text,
  `title` varchar(255) default NULL,
  `description` text,
  `box_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `XHP_TBL_PREFIXmodules`;
CREATE TABLE `XHP_TBL_PREFIXmodules` (
  `name` varchar(255) default NULL,
  `module_id` varchar(255) default NULL,
  `item_id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`item_id`)
);

LOCK TABLES `XHP_TBL_PREFIXmodules` WRITE;
INSERT INTO `XHP_TBL_PREFIXmodules` VALUES ('Guestbook','guestbook',19),('Blog','blog',3),('Admin','users',4),('Links','links',5),('Gallery','gallery',6),('Content','content',8),('Blogroll','blogroll',20);
UNLOCK TABLES;

DROP TABLE IF EXISTS `XHP_TBL_PREFIXpages`;
CREATE TABLE `XHP_TBL_PREFIXpages` (
  `page_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default 'Untitled',
  `active` tinyint(4) NOT NULL default '0',
  `parent_id` int(11) NOT NULL default '-1',
  `menu_order` int(11) NOT NULL default '1',
  `theme` varchar(255) NOT NULL default 'site_theme',
  PRIMARY KEY  (`page_id`)
);

LOCK TABLES `XHP_TBL_PREFIXpages` WRITE;
INSERT INTO `XHP_TBL_PREFIXpages` VALUES (0,'Admin',1,-1,2,'site_scheme'),(2,'Home',1,-1,1,'site_scheme');
UPDATE `XHP_TBL_PREFIXpages` SET page_id=0 WHERE title='Admin';
UNLOCK TABLES;

DROP TABLE IF EXISTS `XHP_TBL_PREFIXtemplate_objects`;
CREATE TABLE `XHP_TBL_PREFIXtemplate_objects` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `placeholder` varchar(255) NOT NULL default '',
  `php_code` text NOT NULL,
  PRIMARY KEY  (`id`)
);

LOCK TABLES `XHP_TBL_PREFIXtemplate_objects` WRITE;
INSERT INTO `XHP_TBL_PREFIXtemplate_objects` VALUES (1,'HEADER','<?php\r\n	require_once (\"inc/htmlheader.inc.php\");\r\n?>'),(2,'SITE_NAME','<?php echo stripslashes(XHP_C_PAGE_TITLE); ?>'),(3,'XHP_MENU','<?php\r\n	echo \"<ul>\\n\";\r\n	draw_main_menu();\r\n	echo \"</ul>\\n\";\r\n?>'),(4,'COPYRIGHT','<?php echo XHP_COPYRIGHT; ?>'),(5,'EDIT_BOX','<?php\r\n	require_once (\"inc/content.inc.php\");\r\n	draw_edit_box ();\r\n?>'),(8,'USERNAME','<?php\n	require_once (\"config.php\");\n	require_once (\"inc/authentication.inc.php\");\n	$username=get_current_modules_user();\n	if ($username)\n		echo \"<h3 style=\\\"color:#FFFFFF\\\">\".$username.\"</h3>\";\n?>\n'),(9,'TIGRA_MENU','<?php\r\n	require_once (\"modules/tigra_menu/tigra_menu.xhpm.php\");\r\n    // initialize module object\r\n    $classname = \"modules_tigra_menu\";\r\n	$objmodule = new $classname();\r\n	$objmodule->dump_tigra_items();\r\n?>\r\n<!-- menu script itself. you should not modify this file -->\r\n<script language=\"JavaScript\" src=\"themes/modules_tigra/menu.js\"></script>\r\n<!-- items structure. menu hierarchy and links are stored there -->\r\n<script language=\"JavaScript\" src=\"themes/modules_tigra/menu_items_modules_<?=session_id()?>.js\"></script>\r\n<!-- files with geometry and styles structures -->\r\n<script language=\"JavaScript\" src=\"themes/modules_tigra/menu_tpl.js\"></script>\r\n<script language=\"JavaScript\">\r\n	<!--//\r\n	// Note where menu initialization block is located in HTML document.\r\n	// Don\'t try to position menu locating menu initialization block in\r\n	// some table cell or other HTML element. Always put it before </body>\r\n\r\n	// each menu gets two parameters (see demo files)\r\n	// 1. items structure\r\n	// 2. geometry structure\r\n\r\n	new menu (MENU_ITEMS, MENU_POS);\r\n	// make sure files containing definitions for these variables are linked to the document\r\n	// if you got some javascript error like \"MENU_POS is not defined\", then you\'ve made syntax\r\n	// error in menu_tpl.js file or that file isn\'t linked properly.\r\n\r\n	// also take a look at stylesheets loaded in header in order to set styles\r\n	//-->\r\n</script>\r\n');
UNLOCK TABLES;

DROP TABLE IF EXISTS `XHP_TBL_PREFIXusers`;
CREATE TABLE `XHP_TBL_PREFIXusers` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(255) default NULL,
  `password` varchar(255) default NULL,
  `session_id` varchar(255) NOT NULL default '',
  `first_name` varchar(255) NOT NULL default '',
  `last_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
);

LOCK TABLES `XHP_TBL_PREFIXusers` WRITE;
INSERT INTO `XHP_TBL_PREFIXusers` VALUES (1,'admin','lars','909c2a48f69630a7ff137afaaba92d93','Laurentiu','Matei');
UNLOCK TABLES;



