<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


function draw_menu_entries($db,$pages,$depth,$parent_active)
{
	require_once ("inc/authentication.inc.php");
	$access_level = get_access_level();
    foreach ($pages as $page)
    {
    	if (($page->active==0)||($parent_active==0))
    	{
			if ($access_level >= XHP_ACCESS_ADMIN)
    		{
		        echo "<li><a href=\"index.php?page=".$page->page_id."\">".$page->title." (".T_("Inactive").")</a>\n";
		    }
	    }
	    else
	    {
	        echo "<li><a href=\"index.php?page=".$page->page_id."\">".$page->title."</a>\n";
	    }

        $children = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE parent_id=".$db->quote($page->page_id)." ORDER BY menu_order ASC");
        if (count($children)>0)
        {
        	echo "<ul>\n";
            draw_menu_entries($db,$children,$depth+1,$page->active);
            echo "</ul>\n";
        }
        echo "</li>\n";
    }
 }

function draw_main_menu()
{
	require_once ("config.php");
    global $db;

    // Draw the pages in the menu recursively
    $pages = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE parent_id=-1 ORDER BY menu_order ASC");
    draw_menu_entries($db,$pages,0,1);

    // Draw logout button if logged in
	require_once("inc/authentication.inc.php");
	$access_level = get_access_level();
	if ($access_level >= XHP_ACCESS_ADMIN)
	{
		// User logged in
		echo "<li><a href=\"action.php?module=users&amp;action=logout\">".T_("Logout")."</a></li>\n";
    }
}

function draw_box($box_name)
{
	global $clean_post, $clean_get, $clean_cookie;
    require_once ("config.php");
    global $db;

	// get page
	$page_id = 0; // just initialize here
	$pages = $db->get_results("SELECT page_id FROM ".XHP_TBL_PREFIX."pages ORDER BY parent_id ASC, menu_order ASC",ARRAY_N);
	if (is_array($pages))
	{
        if (isset($clean_get['page']))
			$page_id = $clean_get['page'];
		else
			// no page requested, default to the first page
			$page_id = $pages[0][0];

		if (!in_array(array(0=>$page_id),$pages))
		{
			// requested page does not exists
			echo "<h3>".T_("Error: Requested page does not exist")."</h3>\n";
			return;
		}
	}
	else
	{
		// no pages defined
		echo "<h3>".T_("Error: No pages defined")."</h3>\n";
		return;
	}

    // if user is registered show admin options
	require_once ("inc/authentication.inc.php");
	$access_level = get_access_level();
	if ($access_level >= XHP_ACCESS_ADMIN)
	{
	    echo "<h3>".T_("Add module");
		echo "<form action=\"action.php?module=engine&amp;action=process_add_module_to_box&amp;box_name=".$box_name."&amp;page_id=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']))."\" method=\"post\" enctype=\"multipart/form-data\">\n";
		echo "<select class=\"textbox\" name=\"frmModule\">\n";
		$modules = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."modules");
		foreach ($modules as $module)
			echo "<option value=\"".$module->module_id."\">".$module->name."</option>\n";
		echo "</select>\n";
		echo "<button class=\"submit\" type=\"submit\">".T_("Add")."</button>\n";
		echo "</form>\n";
	    echo "</h3>\n";
	}
    // end show admin options



	// get modules used in this box in display order
	//echo $page_id;
	$modules = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($page_id)."' AND name='".$db->quote($box_name)."' ORDER BY module_order ASC");
	if (is_array($modules))
	{
		foreach ($modules as $module)
		{
			if ($access_level >= XHP_ACCESS_ADMIN)
			{
				// display module options (delete, move)
				echo "<h3>";
				if ($module->main_module == 1)
					echo "[".T_("Main module")."]\n";

				// if this is the MAIN_CONTENT_BOX in page 0 and admin module,
				// don't allow to delete
				if (($page_id != 0)||($module->name!="MAIN_CONTENT")||($module->module_id!="users"))
				{
					$url = "editwindow.php?module=engine&amp;action=display_move_to_box&amp;box_id=".$module->id."&amp;page=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']));
					echo "[<a href=\"".$url."\" target=\"editdialog\" onClick=\"window.open(this.href,'editdialog','toolbar=no,menubar=no,personalbar=no,width=600,height=500,scrollbars=yes,resizable=yes,modal=yes,dependable=yes'); return false;\">".T_("Move module to another box")."</a>]\n";
				}
				echo "[<a href=\"action.php?module=engine&amp;action=process_make_main_module&amp;box_id=".$module->id."&amp;page_id=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']))."\">".T_("Make main module")."</a>]\n";
		        echo "<a title=\"".T_("Move module up")."\" href=\"action.php?module=engine&amp;action=process_move_module_up&amp;box_id=".$module->id."&amp;page_id=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']))."\"><img src=\"modules/users/up.gif\" alt=\"".T_("Move module up")."\" /></a>\n";
		        echo "<a title=\"".T_("Move module down")."\" href=\"action.php?module=engine&amp;action=process_move_module_down&amp;box_id=".$module->id."&amp;page_id=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']))."\"><img src=\"modules/users/down.gif\" alt=\"".T_("Move module down")."\" /></a>\n";
				if (($page_id != 0)||($module->name!="MAIN_CONTENT")||($module->module_id!="users"))
				{
					echo "<a title=\"".T_("Delete module")."\" href=\"action.php?module=engine&amp;action=process_delete_module_from_box&amp;box_id=".$module->id."&amp;page_id=".$page_id."&amp;from_page=".urlencode(urlencode($_SERVER['QUERY_STRING']))."\"><img src=\"modules/users/delete.gif\" alt=\"".T_("Delete module")."\" /></a>\n";
				}
				echo "</h3>\n";
			}

			// display module
			//echo "Displaying module ".$module->module_id."<br/>";
			require_once ("modules/".$module->module_id."/".$module->module_id.".xhpm.php");

            // initialize module object
            $classname = "xhp_".$module->module_id;
			$objmodule = new $classname($module->module_id,$module->id,$page_id,$access_level);
			//$objmodule->box_id = $module->id;
			//$objmodule->page_id = $page_id;
			//$objmodule->access_level = $access_level;
			//$objmodule->process_input();
			if ((isset($objmodule->clean_get['action']))&&($clean_get['box_id']==$objmodule->box_id))
			{
				// We're using variable functions here
				$action = $objmodule->clean_get['action'];
				$objmodule->$action();
			}
			else
			{
				// This has to be present in every module and it's the default
				// behaviour of the module
				$objmodule->draw_module();
			}
		}
	}

}

function draw_edit_box()
{
	require_once ("config.php");
	require_once ("inc/engine_security.inc.php");

	global $db;
	global $clean_post, $clean_get, $clean_cookie;
	
	require_once ("inc/authentication.inc.php");
	$access_level = get_access_level();

	// display module
	// echo "Displaying module ".$clean_get['module']."<br/>";
	require_once ("modules/".$clean_get['module']."/".$clean_get['module'].".xhpm.php");
	// initialize module object
	$classname = "xhp_".$clean_get['module'];
	$objmodule = new $classname($clean_get['module'],$clean_get['box_id'],$clean_get['page'],$access_level);
	//$objmodule->box_id = $clean_get['box_id'];
	//$objmodule->page_id = $clean_get['page'];
	//$objmodule->access_level = $access_level;
	//$objmodule->process_input();
	if ((isset($objmodule->clean_get['action']))&&($clean_get['box_id']==$objmodule->box_id))
	{
		// We're using variable functions here
		$action = $objmodule->clean_get['action'];
		$objmodule->$action();
	}
	else
	{
		// This has to be present in every module and it's the default
		// behaviour of the module
		$objmodule->draw_module();
	}
}

?>