<?php
	// ==================================================================
	//  Author: Justin Vincent (justin@visunet.ie)
	//	Web: 	http://php.justinvincent.com
	//	Name: 	ezSQL
	// 	Desc: 	Class to make it very easy to deal with mySQL database connections.
	//
	// !! IMPORTANT !!
	//
	//  Please send me a mail telling me what you think of ezSQL
	//  and what your using it for!! Cheers. [ justin@visunet.ie ]
	//
	// ==================================================================
    // note from Eaden : added a global query count
    // also the licence for this file has been reported as
    // LGPL ( hotscripts.com ) , or "do anything you want with it".
    // or Download ezSQL completely Free from here
    // (N.B. There are no license restrictions) - php.justinvincent.php
    // take your pick!
	//
	// ==================================================================
	//	ezSQL Constants

	// ==================================================================
	//	The Main Class

	define ("OBJECT","OBJECT");
	define ("ARRAY_N","ARRAY_N");
	define ("ARRAY_A","ARRAY_A");
	
	class db {

		var $debug_called;
		var $vardump_called;
		var $show_errors = false;
		var $querycount = 0;
		var $use_mysqli = false;
		var $link_identifier;

		// mysql/mysqli wrapper
		function xhp_mysql_connect($hostname,$username,$password)
		{
			if ($this->use_mysqli)
			{
				$this->link_identifier = mysqli_connect($hostname,$username,$password);
				return $this->link_identifier;
			}
			else
			{
				return mysql_connect($hostname,$username,$password);
			}

		}

		function xhp_mysql_select_db($database_name,$link_identifier)
		{
			if ($this->use_mysqli)
			{
				return mysqli_select_db($link_identifier,$database_name);
			}
			else
			{
				return mysql_select_db($database_name,$link_identifier);
			}
		}

		function xhp_mysql_error()
		{
			if ($this->use_mysqli)
			{
				return mysqli_error($this->dbh);
			}
			else
			{
				return mysql_error();
			}
		}

        function xhp_mysql_query($query,$link_identifier)
        {
        	if ($this->use_mysqli)
        	{
        		return mysqli_query($link_identifier,$query);
        	}
        	else
        	{
        		return mysql_query($query,$link_identifier);
        	}
        }

		function xhp_mysql_affected_rows($link_identifier)
		{
			if ($this->use_mysqli)
			{
				return mysqli_affected_rows($link_identifier);
			}
			else
			{
				return mysql_affected_rows($link_identifier);
			}
		}

		function xhp_mysql_insert_id($link_identifier)
		{
			if ($this->use_mysqli)
			{
				return mysqli_insert_id($link_identifier);
			}
			else
			{
				return mysql_insert_id($link_identifier);
			}
		}

		function xhp_mysql_num_fields($result)
		{
			if ($this->use_mysqli)
			{
				return mysqli_num_fields($result);
			}
			else
			{
				return mysql_num_fields($results);
			}
		}

		function xhp_mysql_fetch_field($result)
		{
			if ($this->use_mysqli)
			{
				return mysqli_fetch_field($result);
			}
			else
			{
				return mysql_fetch_field($result);
			}
		}

		function xhp_mysql_fetch_object($result)
		{
			if ($this->use_mysqli)
			{
				return mysqli_fetch_object($result);
			}
			else
			{
				return mysql_fetch_object($result);
			}
		}

		function xhp_mysql_free_result($result)
		{
			if ($this->use_mysqli)
			{
				return mysqli_free_result($result);
			}
			else
			{
				return mysql_free_result($result);
			}
		}


		// end mysql/mysqli wrapper

		// ==================================================================
        ////
        // !connects to the server and selects a database
        function db($dbuser, $dbpassword, $dbname, $dbhost)
		{
			if (function_exists("mysqli_connect"))
				$this->use_mysqli = true;

			$this->dbh = @$this->xhp_mysql_connect($dbhost,$dbuser,$dbpassword);

			if ( ! $this->dbh )
			{
				$this->print_error("<ol><b>Error establishing a database connection!</b><li>Are you sure you have the correct user/password?<li>Are you sure that you have typed the correct hostname?<li>Are you sure that the database server is running?</ol>");
			}


			$this->select($dbname);

		}

		////
		//	Select a DB (if another one needs to be selected)
        function select($db)
		{
			if ( !@$this->xhp_mysql_select_db($db,$this->dbh))
			{
				$this->print_error("<ol><b>Error selecting database <u>$db</u>!</b><li>Are you sure it exists?<li>Are you sure there is a valid database connection?</ol>");
			}
		}

		// ==================================================================
		//	Print SQL/DB error.

		function print_error($str = "")
		{

			// All erros go to the global error array $EZSQL_ERROR..
			global $EZSQL_ERROR;

			// If no special error string then use mysql default..
			if ( !$str ) $str = $this->xhp_mysql_error();

			// Log this error to the global array..
			$EZSQL_ERROR[] = array
							(
								"query" => $this->last_query,
								"error_str"  => $str
							);

			// Is error output turned on or not..
			if ( $this->show_errors )
			{
				// If there is an error then take note of it
				print "<pre>";
				print "SQL/DB Error --\n ";
				print "[<font color=000077>$str</font>]";
				print "</pre>";
			}
			else
			{
				return false;
			}

		}

		// ==================================================================
		//	Turn error handling on or off..

		function show_errors()
		{
			$this->show_errors = true;
		}

		function hide_errors()
		{
			$this->show_errors = false;
		}

		// ==================================================================
		//	Kill cached query results

		function flush()
		{

			// Get rid of these
			$this->last_result = null;
			$this->col_info = null;
			$this->last_query = null;

		}

		// ==================================================================
		//	Basic Query	- see docs for more detail
        ////
        // peformes a mysql query
		function query($query)
		{
			// increase query count :)
			$this->querycount++;


			// Flush cached values..
			$this->flush();

			// Log how the function was called
			$this->func_call = "\$db->query(\"$query\")";

			// Keep track of the last query for debug..
			$this->last_query = $query;

			// Perform the query via std mysql_query function..
			$this->result = $this->xhp_mysql_query($query,$this->dbh);

			// If there was an insert, delete or update see how many rows were affected
			// (Also, If there there was an insert take note of the insert_id
			$query_type = array("insert","delete","update");

			// loop through the above array
			foreach ( $query_type as $word )
			{
				// This is true if the query starts with insert, delete or update
				if ( preg_match("/$word /i",$query) )
				{
					$this->rows_affected = $this->xhp_mysql_affected_rows($this->dbh);

					// This gets the insert ID
					if ( $word == "insert" )
					{
						$this->insert_id = $this->xhp_mysql_insert_id($this->dbh);
					}

					$this->result = false;
				}

			}

			if ( $this->xhp_mysql_error() )
			{

				// If there is an error then take note of it..
				$this->print_error();

			}
			else
			{

				// In other words if this was a select statement..
				if ( $this->result )
				{

					// =======================================================
					// Take note of column info

					$i=0;
					while ($i < @$this->xhp_mysql_num_fields($this->result))
					{
						$this->col_info[$i] = @$this->xhp_mysql_fetch_field($this->result);
						$i++;
					}

					// =======================================================
					// Store Query Results

					$i=0;
					while ( $row = @$this->xhp_mysql_fetch_object($this->result) )
					{

						// Store relults as an objects within main array
						$this->last_result[$i] = $row;

						$i++;
					}

					// Log number of rows the query returned
					$this->num_rows = $i;

					@$this->xhp_mysql_free_result($this->result);

					// If this was not a select..
					if ( preg_match("/(select|show|desc) /i",$query) )
					{

						// If there were results then return true for $db->query
						if ( $i )
						{
							return true;

						}
						else
						{
							return false;
						}
					}
					else
					{
						// Update insert etc. was good..
						return true;
					}

				}
				else
				{
					return true;
				}
			}
		}

		// ==================================================================
		////
        // !Get one variable from the DB - see docs for more detail
		function get_var($query=null,$x=0,$y=0)
		{

			// Log how the function was called
			$this->func_call = "\$db->get_var(\"$query\",$x,$y)";

			// If there is a query then perform it if not then use cached results..
			if ( $query )
			{
				$this->query($query);
			}

			// Extract var out of cached results based x,y vals
			$values = array();
			if ( $this->last_result[$y] )
			{
				$values = array_values(get_object_vars($this->last_result[$y]));
			}

			// If there is a value return it else return null
			if (count($values)>=$x+1)
				return $values[$x]!=''?$values[$x]:null;
			else
				return null;
		}

		////
		//	Get one row from the DB - see docs for more detail
		function get_row($query=null,$output=OBJECT,$y=0)
		{

			// Log how the function was called
			$this->func_call = "\$db->get_row(\"$query\",$output,$y)";

			// If there is a query then perform it if not then use cached results..
			if ( $query )
			{
				$this->query($query);
			}

			// If the output is an object then return object using the row offset..
			if ( $output == OBJECT )
			{
				return $this->last_result[$y]?$this->last_result[$y]:null;
			}
			// If the output is an associative array then return row as such..
			elseif ( $output == ARRAY_A )
			{
				return $this->last_result[$y]?get_object_vars($this->last_result[$y]):null;
			}
			// If the output is an numerical array then return row as such..
			elseif ( $output == ARRAY_N )
			{
				return $this->last_result[$y]?array_values(get_object_vars($this->last_result[$y])):null;
			}
			// If invalid output type was specified..
			else
			{
				$this->print_error(" \$db->get_row(string query, output type, int offset) -- Output type must be one of: OBJECT, ARRAY_A, ARRAY_N");
			}

		}

		////
		// !Function to get 1 column from the cached result set based in X index
		// see docs for usage and info
		function get_col($query=null,$x=0)
		{

			// If there is a query then perform it if not then use cached results..
			if ( $query )
			{
				$this->query($query);
			}

			// Extract the column values
			for ( $i=0; $i < count($this->last_result); $i++ )
			{
				$new_array[$i] = $this->get_var(null,$x,$i);
			}

			return $new_array;
		}

		////
		// !Return the the query as a result set - see docs for more details
		function get_results($query=null, $output = OBJECT)
		{

			// Log how the function was called
			$this->func_call = "\$db->get_results(\"$query\", $output)";

			// If there is a query then perform it if not then use cached results..
			if ( $query )
			{
				$this->query($query);
			}

			// Send back array of objects. Each row is an object
			if ( $output == OBJECT )
			{
				return $this->last_result;
			}
			elseif ( $output == ARRAY_A || $output == ARRAY_N )
			{
				if ( $this->last_result )
				{
					$i=0;
					foreach( $this->last_result as $row )
					{

						$new_array[$i] = get_object_vars($row);

						if ( $output == ARRAY_N )
						{
							$new_array[$i] = array_values($new_array[$i]);
						}

						$i++;
					}

					return $new_array;
				}
				else
				{
					return null;
				}
			}
		}


		// ==================================================================
		// Function to get column meta data info pertaining to the last query
		// see docs for more info and usage

		function get_col_info($info_type="name",$col_offset=-1)
		{

			if ( $this->col_info )
			{
				if ( $col_offset == -1 )
				{
					$i=0;
					foreach($this->col_info as $col )
					{
						$new_array[$i] = $col->{$info_type};
						$i++;
					}
					return $new_array;
				}
				else
				{
					return $this->col_info[$col_offset]->{$info_type};
				}

			}

		}
		
		function quote($value)
		{
			// Stripslashes
			if (get_magic_quotes_gpc()) 
			{
				$value = stripslashes($value);
			}
			if ($this->use_mysqli)
			{
				$value = mysqli_real_escape_string($this->link_identifier,$value);
			}
			else
			{
				$value = mysql_real_escape_string($value);
			}
			return $value;
		}
		
}
?>
