/**
 * The ImageManager plugin javascript.
 * @author $Author: cjlars $
 * @version $Id: file-manager.js,v 1.1.1.1 2005/06/19 13:16:20 cjlars Exp $
 * @package ImageManager
 */

/**
 * To Enable the plug-in add the following line before HTMLArea is initialised.
 *
 * HTMLArea.loadPlugin("ImageManager");
 *
 * Then configure the config.inc.php file, that is all.
 * For up-to-date documentation, please visit http://www.zhuo.org/htmlarea/
 */

/**
 * It is pretty simple, this file over rides the HTMLArea.prototype._insertImage
 * function with our own, only difference is the popupDialog url
 * point that to the php script.
 */
function FileManager(editor)
{
	this.editor = editor;
	var cfg = editor.config;
	var tt = FileManager.I18N;
	var bl = FileManager.btnList;
	var self = this;

	// register the toolbar buttons provided by this plugin
	var toolbar = [];
	for (var i in bl) {
		var btn = bl[i];
		if (!btn) {
			toolbar.push("separator");
		} else {
			var id = "FM-" + btn[0];
			cfg.registerButton(id, tt[id], editor.imgURL("file_manager.gif", "FileManager"), false,
					   function(editor,id) {
						   // dispatch button press event
						   self.buttonPress(editor,id);
					   }, btn[1]);
			toolbar.push(id);
		}
	}

	for (var i in toolbar) {
		cfg.toolbar[1].push(toolbar[i]);
	}

};

FileManager._pluginInfo = {
	name          : "FileManager",
	version       : "1.0",
	developer     : "Xiang Wei Zhuo, Laurentiu Lars Matei",
	developer_url : "http://lars.targetit.ro",
	sponsor       : "Target: IT",
	sponsor_url   : "http://www.targetit.ro/",
	license       : "GPL"
};

FileManager.btnList = [
	null, // separator
	["file-manager"]
	];

FileManager.prototype.buttonPress = function(editor,id) {
	FileManager.editor = editor;
	FileManager.init = true;
	var outparam = null;
	if (typeof link == "undefined") {
		link = editor.getParentElement();
		if (link && !/^a$/i.test(link.tagName))
			link = null;
	}
	if (link) outparam = {
		f_url    : HTMLArea.is_ie ? link.href : link.getAttribute("href")
	};

	var manager = _editor_url + 'plugins/FileManager/manager.php';

	Dialog(manager, function(param) {
		if (!param) {	// user must have pressed Cancel
			return false;
		}
		var img = link;
		if (!img) {
			var sel = editor._getSelection();
			var range = editor._createRange(sel);
			editor._doc.execCommand("createlink", false, param.f_url);
			if (HTMLArea.is_ie) {
				img = range.parentElement();
				// wonder if this works...
				if (img.tagName.toLowerCase() != "a") {
					img = img.previousSibling;
				}
			} else {
				img = range.startContainer.previousSibling;
			}
		} else {
			img.href = param.f_url;
		}

		for (field in param) {
			var value = param[field];
			switch (field) {
			    case "f_alt"    : img.title	 = value; break;
			}
		}

	}, outparam);
};