<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<!-- DW6 -->
<head>
<link rel="stylesheet" href="themes/xhp/xhp.css" type="text/css">
<title>XHP installation</title>
</head>
<body>
<div id="masthead">
<img src="images/logo.gif" alt="XHP Installation"/>
</div>
<div id="navBar">
  <div class="relatedLinks">
<?php
	draw_step_menu();
?>
  </div>
</div>
<!--end navBar div -->
<div id="headlines">
<h3>XHP Installation</h3>
</div>
<!--end headlines -->
<div id="content">
<?php
	if (isset($_GET['step']))
		$step = $_GET['step'];
	else
		$step = 1;
	draw_step ($step);
?>
</div>
<!--end content -->
<div id="siteInfo">
<a href="http://xhp.targetit.ro/">Powered by XHP CMS v0.5.1</a><br/>
<a href="http://lars.targetit.ro/">Site engine is copyright  2003-2006 Laurentiu Matei</a></div> 
</div>
<br>
</body>
</html>
<?php
function draw_step_menu()
{
	// The install steps are
	// - chech requirements
	//		- PHP version +
	//		- GD version +
	//		- check safe mode
	// - check writable folders (or create them)
	//		- albums
	//		- albums/tmp
	//		- cache (still needed?)
	//		- imagemanager
	//		- languages
	//		- modules
	//		- templates
	//		- tmp
	//		- config.php
	// - write config file
	// - import database
	// - site settings
	// - finish: congratulations, delete install file, redirect to index
	// - delete install file
	echo "<div id=step1><h3>1. Check Requirements</h3></div>";
	echo "<div id=step2><h3>2. Check writable folders and files</h3></div>";
	echo "<div id=step3><h3>3. Write config file</h3></div>";
	echo "<div id=step4><h3>4. Import database</h3></div>";
	echo "<div id=step5><h3>5. Site settings</h3></div>";
	echo "<div id=step6><h3>6. Finish</h3></div>";
}

function draw_step ($step)
{
	switch ($step)
	{
		case 1:
			draw_step_1();
			break;
		case 2:
			draw_step_2();
			break;
		case 3:
			draw_step_3();
			break;
		case 4:
			draw_step_4();
			break;
		case 5:
			draw_step_5();
			break;
		case 6:
			draw_step_6();
			break;
		default:
			break;
	}
}

function draw_step_1()
{
	echo "<script>step1.style.backgroundColor='white'</script>";
	echo "<h2>1. Check Requirements</h2>";
	$success = true;
	// PHP version check
	echo "<p>Checking PHP version... \n";
	echo phpversion().".</p>";
	if (version_compare("4.2.0",phpversion(),"<=")==0)
	{
		$success = false;
		echo ("<p style=\"color: #FF0000\">Your PHP version is too old. You need at least PHP 4.2.0.</p>");
	}
	// End PHP version check

	// GD library check
	if (!extension_loaded('gd'))
	{
		$success = false;
		echo ("<p style=\"color: #FF0000\">Your PHP install misses the GD library.</p>");
	}
	else
	{
		$gdinfo = gd_info();
		echo "<p>GD library ".$gdinfo['GD Version']." installed.</p>\n";
		if ($gdinfo['JPG Support']==false)
		{
			$success = false;
			echo ("<p style=\"color: #FF0000\">Your GD library does not have JPEG support (needed for XHP gallery).</p>\n");
		}
		else
			echo "<p>JPEG support OK.</p>";
		if ($gdinfo['PNG Support']==false)
		{
			$success = false;
			echo ("<p style=\"color: #FF0000\">Your GD library does not have PNG support (needed for XHP gallery).</p>\n");
		}
		else
			echo "<p>PNG support OK.</p>";
	}
	// End GD library check

	// ZIP support check
	if (!function_exists('zip_open'))
	{
		$success = false;
		echo ("<p style=\"color: #FF0000\">Your PHP install misses ZIP support.</p>");
	}
	else
		echo "<p>ZIP support OK.</p>";
	// End ZIP support check

    // XML support check
    if (!function_exists('xml_parser_create'))
    {
        $success = false;
        echo ("<p style=\"color: #FF0000\">Your PHP install misses XML support.</p>");
    }
    else
        echo "<p>XML support OK.</p>";
    // End ZIP support check

	// Check safe mode
	if (ini_get("safe_mode")=="1")
	{
		$success = false;
		echo "<p style=\"color: #FF0000\">Safe mode on. XHP need the PHP safe mode to be off.</p>";
	}
	else
	{
		echo "<p>Safe mode off.</p>";
	}
	// End check safe mode

	if ($success)
	{
		echo "<p>XHP requirements are met. Click Next to go on with the install process.</p>\n";
	}
	else
	{
		echo "<p style=\"color: #FF0000\">Some requirements are not met. In order to continue, please review and solve the problems written in red above and then refresh this page. You can still go on but you do it on your own risk. It's highly recommended to solve the problems above first.</p>";
	}
		echo "<a href=\"install.php?step=2\">Next</a>\n";
}

function check_writable($filename)
{
	$retval = true;
    if (is_writable($filename))
    {
    	echo "<p>".$filename." exists and is writable.</p>\n";
    }
    else
    {
    	$retval = false;
    	$filetype = "folder";
    	if ($filename == "config.php")
    		$filetype = "file";
    	echo "<p style=\"color: #FF0000\">".$filename." ".$filetype." must exist and must be writable by the web server user.</p>\n";
    }
    return $retval;
}

function draw_step_2()
{
	echo "<script>step2.style.backgroundColor='white'</script>";
	echo "<h2>2. Check writable folders and files</h2>";
	$success = true;
	//		- albums
	//		- albums/tmp
	//		- cache (still needed?)
	//		- imagemanager
	//		- filemanager
	//		- languages
	//		- modules
	//		- templates
	//		- tmp
	//		- dbconfig.php
	//		- install.php (we need to delete it in the end)

    clearstatcache();
	if (!check_writable("albums"))
	{
		echo "<p style=\"color: #FF0000\">albums directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("albums/tmp"))
	{
		echo "<p style=\"color: #FF0000\">albums/tmp directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("cache"))
	{
		echo "<p style=\"color: #FF0000\">cache directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("imagemanager"))
	{
		echo "<p style=\"color: #FF0000\">imagemanager directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("filemanager"))
	{
		echo "<p style=\"color: #FF0000\">filemanager directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("languages"))
	{
		echo "<p style=\"color: #FF0000\">languages directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("modules"))
	{
		echo "<p style=\"color: #FF0000\">modules directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("themes"))
	{
		echo "<p style=\"color: #FF0000\">themes directory is not writable.</p>";
		$success = false;
	}
	if (!check_writable("tmp"))
	{
		echo "<p style=\"color: #FF0000\">tmp directory is not writable.</p>";
		$success = false;
	}
	if (file_exists("dbconfig.php"))
	{
		if (!check_writable("dbconfig.php"))
		{
			echo "<p style=\"color: #FF0000\">dbconfig.php file is not writable.</p>";
			$success = false;
		}
	}
	if (!check_writable("install.php"))
	{
		echo "<p style=\"color: #FF0000\">install.php file is not writable.</p>";
		$success = false;
	}
 
	if ($success)
	{
		echo "<p>All files and folders seem to have the needed access rights set. Click Next to go on with the install process.</p>\n";
	}
	else
	{
		echo "<p style=\"color: #FF0000\">Some files or folders don't have the needed access rights set. In order to continue, please review and solve the problems written in red above and then refresh this page. You can still go on but you do it on your own risk. It's highly recommended to solve the problems above first.</p>";
	}
		echo "<a href=\"install.php?step=3\">Next</a>\n";
}

function draw_step_3()
{
	echo "<script>step3.style.backgroundColor='white'</script>";
	echo "<h2>3. Write config file</h2>";
	$success = true;
	if (isset($_POST['submit']))
	{
		if (function_exists("mysqli_connect"))
		{
			$link = mysqli_connect($_POST['frmMysqlHost'],$_POST['frmMysqlUser'],$_POST['frmMysqlPassword']);
			if ($link)
			{
				if (!mysqli_select_db($link,$_POST['frmMysqlDatabase']))
					$success = false;
				mysqli_close ($link);
			}
			else
				$success = false;
		}
		else
		{
			$link = mysql_connect($_POST['frmMysqlHost'],$_POST['frmMysqlUser'],$_POST['frmMysqlPassword']);
			if ($link)
			{
				if (!mysql_select_db($_POST['frmMysqlDatabase']))
					$success = false;
				mysql_close ($link);
			}
			else
				$success = false;
		}
		if ($success)
		{
			// Write the config file
            $fd = fopen ("dbconfig.php","w");
            fwrite ($fd,"<?php\n");
			fwrite ($fd,"define (\"XHP_DB_HOST\",\"".$_POST['frmMysqlHost']."\");\n");
			fwrite ($fd,"define (\"XHP_DB_USER\",\"".$_POST['frmMysqlUser']."\");\n");
			fwrite ($fd,"define (\"XHP_DB_PW\",\"".$_POST['frmMysqlPassword']."\");\n");
			fwrite ($fd,"define (\"XHP_DB_NAME\",\"".$_POST['frmMysqlDatabase']."\");\n");
			fwrite ($fd,"define (\"XHP_TBL_PREFIX\",\"".$_POST['frmTablePrefix']."\");\n");
			fwrite ($fd,"?>");
            fclose ($fd);
			echo "<p>Config file written.</p>\n";
			echo "<a href=\"install.php?step=4\">Next</a>\n";
		}
	}
	if ((!isset($_POST['submit']))||(!$success))
	{
?>
<form action="install.php?step=3" method="post">
<table>
<tr><td>XHP table prefix:</td><td><input type="text" name="frmTablePrefix" size="40" value="xhp_"/></td></tr>
<tr><td>MySQL host:</td><td><input type="text" name="frmMysqlHost" size="40" value="localhost"/></td></tr>
<tr><td>MySQL user:</td><td><input type="text" name="frmMysqlUser" size="40" value="username"/></td></tr>
<tr><td>MySQL password:</td><td><input type="text" name="frmMysqlPassword" size="40" value="password"/></td></tr>
<tr><td>MySQL database:</td><td><input type="text" name="frmMysqlDatabase" size="40" value="database"/></td></tr>
</table>
<input type="submit" name="submit" value="Write"/>
</form>
<?php
	}

}

function draw_step_4()
{
	require_once ("dbconfig.php");
    require_once ("inc/ez_sql.inc.php");
    global $db;
    $db = new db(XHP_DB_USER, XHP_DB_PW, XHP_DB_NAME, XHP_DB_HOST);
    $db->show_errors();
	echo "<script>step4.style.backgroundColor='white'</script>";
	echo "<h2>4. Import database</h2>";
	$success = true;

	if (!($fp = fopen ("doc/xhp.0.5.1.sql","r")))
	{
		echo "<p style=\"color: #FF0000\">Failed opening SQL file.</p>";
		$success = false;
	}
	else
	{
		$sqlfile = "";
		while ($data = fread($fp,4096))
			$sqlfile .= $data;
		fclose ($fp);
		$sqlfile = str_replace("XHP_TBL_PREFIX",XHP_TBL_PREFIX,$sqlfile);

		// process SQL file
		require_once ("inc/sqlfile.inc.php"); // PHPMyAdmin library
		$queries = array();
		if (!PMA_splitSqlFile($queries,$sqlfile))
		{
			echo "<p style=\"color: #FF0000\">Failed importing SQL file</p>";
			$success = false;
		}
		else
		{
			$i = 0;
			foreach ($queries as $query)
			{
				$i++;
				if (!$db->query ($query))
				{
					$success = false;
				}
			}
		}
	}

	if ($success)
	{
		echo "<p>Database imported successfully.</p>\n";
		echo "<a href=\"install.php?step=5\">Next</a>\n";
	}
	else
	{
		echo "<p style=\"color: #FF0000\">Database import failed</p>";
		echo "<a href=\"install.php?step=4\">Try again</a>\n";
	}
}

function draw_step_5()
{
	require_once ("config.php");
	echo "<script>step5.style.backgroundColor='white'</script>";
	echo "<h2>5. Site settings</h2>";
	$success = true;
	$err_no = 0;
	if (isset($_POST['submit']))
	{
		if ($_POST['frmNewPassword'] <> $_POST['frmConfNewPassword'])
		{
			$success = false;
			$err_no = 1;
		}
		if ($success == true)
		{
			$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($_POST['frmPageTitle'])."' WHERE variable='PAGE_TITLE'");
			// Make sure the URL ends with "/"
			$pageurl = "";
			if (strrpos($_POST['frmPageUrl'],"/")!=strlen($_POST['frmPageUrl'])-1)
				$pageurl = $_POST['frmPageUrl']."/";
			else
				$pageurl = $_POST['frmPageUrl'];
			$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($pageurl)."' WHERE variable='PAGE_URL'");
			$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($_POST['frmPageDescription'])."' WHERE variable='PAGE_DESCRIPTION'");
			$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($_POST['frmLanguage'])."' WHERE variable='LANGUAGE'");
			$db->query ("UPDATE ".XHP_TBL_PREFIX."users SET first_name='".$db->quote($_POST['frmFirstName'])."', last_name='".$db->quote($_POST['frmLastName'])."', password='".$db->quote($_POST['frmNewPassword'])."' WHERE username='admin'");
			echo "<p>Site settings saved successfully.</p>\n";
			echo "<a href=\"install.php?step=6\">Next</a>\n";
		}
		else
		{
			echo "<p style=\"color: #FF0000\">Site settings save failed</p>";
			switch ($err_no)
			{
				case 1:
					echo "<p style=\"color: #FF0000\">The Admin password must be the same as Confirm Admin password</p>";
					break;
			}
			echo "";
			echo "<a href=\"install.php?step=5\">Try again</a>\n";
			return;
		}
	}

	if ((!isset($_POST['submit']))||(!$success))
	{
		echo "<form action=\"install.php?step=5\" method=\"post\" />\n";
		echo "<table>\n";
		echo "<tr><td>Site name:</td><td><input type=\"text\" size=\"60\" name=\"frmPageTitle\" value=\"".stripslashes(XHP_C_PAGE_TITLE)."\"/></td></tr>\n";
		echo "<tr><td>Site URL:</td><td><input type=\"text\" size=\"60\" name=\"frmPageUrl\" value=\"".XHP_C_PAGE_URL."\"/></td></tr>\n";
		echo "<tr><td>Site description:</td><td><input type=\"text\" size=\"60\" name=\"frmPageDescription\" value=\"".stripslashes(XHP_C_PAGE_DESCRIPTION)."\"/></td></tr>\n";
		echo "<tr><td>Site language:</td><td>";
		// get list of available languages
		$dir = "languages";
		$languages = array();
		if (is_dir($dir))
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
					if (substr($file,0,5)=="lang-")
					{
						$language = substr($file,5);
						$index = strpos($language,"-");
						if ($index !== false)
							$language = substr($language,0,$index);
						$index = strpos($language,".");
						if ($index !== false)
							$language = substr($language,0,$index);
						if (!in_array($language,$languages))
							$languages[] = $language;
					}
				closedir($dh);
			}
		}
		$current_language = $db->get_var ("SELECT value FROM ".XHP_TBL_PREFIX."config WHERE variable='LANGUAGE' LIMIT 1");
		echo "<select name=\"frmLanguage\">\n";
		foreach ($languages as $language)
		{
			echo "  <option value=\"".$language."\" ";
			if ($current_language==$language)
			{
				echo " selected ";
			}
			echo ">".$language."</option>\n";
		}
		echo "</select>\n";
		echo "</td></tr>\n";

		$user = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."users WHERE username='admin'");
		echo "<tr><td>First name:</td><td><input type=\"text\" size=\"60\" name=\"frmFirstName\" value=\"".stripslashes($user->first_name)."\"/></td></tr>\n";
		echo "<tr><td>Last name:</td><td><input type=\"text\" size=\"60\" name=\"frmLastName\" value=\"".stripslashes($user->last_name)."\"/></td></tr>\n";

		echo "<tr><td>Admin password:</td><td><input type=\"password\" name=\"frmNewPassword\" /></td></tr>\n";
		echo "<tr><td>Confirm Admin password:</td><td><input type=\"password\" name=\"frmConfNewPassword\" /></td></tr>\n";
		echo "<tr><td colspan=\"2\"><input type=\"submit\" name=\"submit\" class=\"submit\" value=\"Save\"/></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		if (!$success)
		{
			echo "<p style=\"color: #FF0000\">Site settings save failed</p>";
			echo "<a href=\"install.php?step=5\">Try again</a>\n";
		}
	}

}

function draw_step_6()
{
	unlink ("install.php");
	echo "<script>step6.style.backgroundColor='white'</script>";
	echo "<p>XHP has been successfully installed.</p>\n";
	echo "<a href=\"index.php\">Go to your new site</a>\n";
}


?>
