<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_blog extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "show_archives";
	$this->valid_actions[] = "show_single_entry";
	$this->valid_actions[] = "process_delete_entry";
	$this->valid_actions[] = "show_month_archive";
	$this->valid_actions[] = "add_entry";
	$this->valid_actions[] = "display_blog_settings";
	$this->valid_actions[] = "edit_entry";
	$this->valid_actions[] = "add_comment";
	$this->valid_actions[] = "edit_comment";
	$this->valid_actions[] = "process_edit_entry";
	$this->valid_actions[] = "process_add_entry";
	$this->valid_actions[] = "process_blog_settings";
	$this->valid_actions[] = "process_new_comment";
	$this->valid_actions[] = "process_edit_comment";
	$this->valid_actions[] = "process_delete_comment";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['month'] must be a month that is present in the database
	if (isset($_GET['month']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' AND LEFT(date_created,7)='".$db->quote($_GET['month'])."'")>0)
			$this->clean_get['month'] = $_GET['month'];
	}
	
	// $_GET['post_id'] must be a valid post id
	if (isset($_GET['post_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' AND post_id='".$db->quote($_GET['post_id'])."'")>0)
			$this->clean_get['post_id'] = $_GET['post_id'];
	}
	
	// $_GET['comment_id'] must be a valid comment id
	if (isset($_GET['comment_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blog_comments WHERE id='".$db->quote($_GET['comment_id'])."'")>0)
			$this->clean_get['comment_id'] = $_GET['comment_id'];
	}
	
	// $_POST['frmTitle'] doesn't have constraints
	if (isset($_POST['frmTitle']))
		$this->clean_post['frmTitle'] = $_POST['frmTitle'];
		
	// $_POST['ta'] doesn't have constraints
	if (isset($_POST['ta']))
		$this->clean_post['ta'] = $_POST['ta'];

	// $_POST['frmBlogAllowComments'] must be "yes" or "no"
	if (isset($_POST['frmBlogAllowComments']))
	{
		if ($_POST['frmBlogAllowComments'] == "yes")
			$this->clean_post['frmBlogAllowComments'] = "yes";
		else if ($_POST['frmBlogAllowComments'] == "no")
			$this->clean_post['frmBlogAllowComments'] = "no";
	}

	// $_POST['frmSettingsExist'] must be 0 or 1
	if (isset($_POST['frmSettingsExist']))
	{
		if ($_POST['frmSettingsExist'] == 0)
			$this->clean_post['frmSettingsExist'] = 0;
		else if ($_POST['frmSettingsExist'] == 1)
			$this->clean_post['frmSettingsExist'] = 1;
	}

	// TODO $_POST['frmBlogImageUrl'] should be a valid URL
	if (isset($_POST['frmBlogImageUrl']))
	{
		$this->clean_post['frmBlogImageUrl'] = $_POST['frmBlogImageUrl'];
	}
	
	// $_POST['frmBlogTitle'] doesn't have constraints
	if (isset($_POST['frmBlogTitle']))
		$this->clean_post['frmBlogTitle'] = $_POST['frmBlogTitle'];

	// $_POST['frmBlogDescription'] doesn't have constraints
	if (isset($_POST['frmBlogDescription']))
		$this->clean_post['frmBlogDescription'] = $_POST['frmBlogDescription'];

	// $_POST['frmName'] is entered by users and must not have custom tags
	if (isset($_POST['frmName']))
	{
		if (is_string($_POST['frmName']))
		{
			$this->clean_post['frmName'] = strip_tags($_POST['frmName']);
		}
	}
	
	// $_POST['frmCommentText'] is entered by users and must not have custom tags
	if (isset($_POST['frmCommentText']))
	{
		if (is_string($_POST['frmCommentText']))
		{
			$this->clean_post['frmCommentText'] = strip_tags($_POST['frmCommentText']);
		}
	}
}

function delete_instance()
{
	require_once ("config.php");
	global $db;
	
	// delete xml feeds
	@unlink ("modules/blog/atom_0_3_".$this->box_id.".xml");
	@unlink ("modules/blog/rss_2_0_".$this->box_id.".xml");
	
	// delete comments
	$post_ids = $db->get_results ("SELECT DISTINCT post_id FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($post_ids))
	{
		foreach ($post_ids as $post_id)
		{
			$db->query ("DELETE FROM ".XHP_TBL_PREFIX."blog_comments WHERE post_id='".$db->quote($post_id->post_id)."'");
		}
	}
	// delete posts
	$query = "DELETE FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
	// delete settings
	$query = "DELETE FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
}

function delete_module()
{
	require_once ("config.php");
	global $db;

	// delete content from all instances first
	$instances = $db->get_results ("SELECT DISTINCT box_id FROM ".XHP_TBL_PREFIX."blog_posts");
	if (is_array($instances))
	{
		$old_box_id = $this->box_id;
		foreach ($instances as $instance)
		{
			$this->box_id = $instance->box_id;
			$this->delete_instance();
		}
		$this->box_id = $old_box_id;
	}
	
	// delete tables
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blog_settings";
	$db->query ($query);
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blog_posts";
	$db->query ($query);
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blog_comments";
	$db->query ($query);
}


function change_headers()
{
	// redefine function change_headers
	global $db;
	// add live bookmark to the feed of this blog
	$blog_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."'");
	if ($blog_title == null)
		$blog_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($this->page_id)."'");
	$this->set_header("live_bookmark","<link rel=\"alternate\" type=\"application/x.atom+xml\" title=\"".$blog_title."\" href=\"modules/blog/atom_0_3_".$this->box_id.".xml\">\n");
	
	
	if (isset($this->clean_get['action']))
	{
		// only change headers for archives and single entries
		switch ($this->clean_get['action'])
		{
			case "show_month_archive":
				$blog_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."'");
				if ($blog_title == null)
					$blog_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($this->page_id)."'");
				$this->set_header("title","<title>".$blog_title." - ".$this->T_("Archive for")." ".$this->date_mysql2php($this->clean_get['month'])." - ".XHP_C_PAGE_TITLE."</title>\n");
				break;
			case "show_single_entry":
				$title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."blog_posts WHERE post_id='".$db->quote($this->clean_get['post_id'])."'");
				$this->set_header("title","<title>".$title." - ".XHP_C_PAGE_TITLE."</title>\n");
				break;
			case "add_entry":
			case "edit_entry":
				// add htmlarea script in header
				$htmlarea = "<script type=\"text/javascript\">\n"
					."_editor_url = \"inc/htmlarea/\";\n"
					."_editor_lang = \"en\";\n"
					."</script>\n"
					."<script type=\"text/javascript\" src=\"inc/htmlarea/htmlarea.js\"></script>\n"
					."<script type=\"text/javascript\">\n"
					//."//<![CDATA[\n"
					."HTMLArea.loadPlugin(\"ImageManager\");\n"
					."HTMLArea.loadPlugin(\"FileManager\");\n"
					."var editor = null;\n"
					."initdocument = function () {\n"
					."editor = new HTMLArea(\"ta\");\n"
					."editor.registerPlugin(FileManager);\n"
					."editor.generate();\n"
					."}\n"
					."function addEvent(obj, evType, fn)\n"
					."{\n"
					."if (obj.addEventListener) { obj.addEventListener(evType, fn, true); return true; }\n"
					."else if (obj.attachEvent) {  var r = obj.attachEvent(\"on\"+evType, fn);  return r;  }\n"
					."else {  return false; }\n"
					."}\n"
					."addEvent(window, 'load', initdocument);\n"
					//."//]]>\n"
					."</script>\n";
				$this->set_header("htmlarea",$htmlarea);
			default:
				break;
		}
	}
	// call the base function we are extending
	xhp_module::change_headers();
}

function draw_module()
{
	require_once ("config.php");
	global $db;

	if ($this->access_level >= XHP_ACCESS_EDIT)
		echo "<h3>".$this->T_("Blog module")."</h3>\n";
	echo "<h4>\n";
   	echo "[<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_archives\">".$this->T_("Archives")."</a>]\n";
	echo " [<a href=\"modules/blog/rss_2_0_".$this->box_id.".xml\">".$this->T_("RSS")."</a>]\n";
	echo " [<a href=\"modules/blog/atom_0_3_".$this->box_id.".xml\">".$this->T_("Atom")."</a>]\n";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "["; $this->draw_edit_link($this->T_("Add post"),"blog","add_entry",null); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Blog settings"),"blog","display_blog_settings",null); echo "]\n";
	}
	echo "</h4>\n";
	$this->test_error();

	$posts = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' ORDER BY date_modified DESC LIMIT 10");
	if(is_array($posts))
	{
		foreach ($posts as $post)
		{
			echo "<br/><h3><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_single_entry&amp;post_id=".$post->post_id."\">".stripslashes($post->title)."</a></h3>\n";
			echo "<div class=\"frame\">".stripslashes($post->content)."</div>\n";
			echo "<h4>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
				echo "["; $this->draw_edit_link($this->T_("Edit"),"blog","edit_entry",null,array("post_id" => $post->post_id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete"),"blog","process_delete_entry",null,array("post_id" => $post->post_id)); echo "]";
			}
			echo ("<br/>".$this->T_("Posted")." ".$this->date_mysql2php($post->date_created));
			echo ("<br/>Modified ".$this->date_mysql2php($post->date_modified));
			echo "</h4>\n";
			$blog_settings = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
			if (!$blog_settings)
			{
				$blog_settings->allow_comments = 1;
			}
			if ($blog_settings->allow_comments == 1)
			{
				// Display comments and add coment link
				$comments = $db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blog_comments WHERE post_id='".$db->quote($post->post_id)."'");
				echo "<h4>".$comments." ".$this->T_ngettext("comment","comments",$comments)."</h4>\n";
			}
			echo "<hr />\n";
		}
	}
	else
	{
		echo "<p>".$this->T_("The Blog contains no posts")."</p>\n";
	}
}

// Internal functions
function nls_and_urls($ret)
{
	$ret = ' ' . $ret;
	// matches an "xxxx://yyyy" URL at the start of a line, or after a space.
	// xxxx can only be alpha characters.
	// yyyy is anything up to the first space, newline, comma, double quote or <
	$ret = preg_replace("#([\t\r\n ])([a-z0-9]+?){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a rel="nofollow" href="\2://\3" target="_blank">\2://\3</a>', $ret);

	// matches a "www|ftp.xxxx.yyyy[/zzzz]" kinda lazy URL thing
	// Must contain at least 2 dots. xxxx contains either alphanum, or "-"
	// zzzz is optional.. will contain everything up to the first space, newline,
	// comma, double quote or <.
	$ret = preg_replace("#([\t\r\n ])(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a rel="nofollow" href="http://\2.\3" target="_blank">\2.\3</a>', $ret);

	// matches an email@domain type address at the start of a line, or after a space.
	// Note: Only the followed chars are valid; alphanums, "-", "_" and or ".".
	$ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);

	// Remove our padding..
	$ret = substr($ret, 1);

	return nl2br($ret);
}
// End module internal functions

// Display functions
function edit_entry()
{
	require_once ("config.php");
	global $db;
	echo "<fieldset><legend>".$this->T_("Blog module - edit entry")."</legend>";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$post = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_posts WHERE post_id='".$db->quote($this->clean_get['post_id'])."' LIMIT 1");
		$this->draw_form_tag("blog","process_edit_entry","page=".$this->page_id,array("post_id" => $this->clean_get['post_id']),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Title").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmTitle\" size=\"80\" "
			."value=\"".stripslashes($post->title)."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Body").":</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea id=\"ta\" name=\"ta\" style=\"width: 99%; height: 300px;\">"
			.stripslashes($post->content)."</textarea></td>\n";
		echo "</tr>\n";
		echo "</tr><td colspan=\"2\">\n";
		echo "<button type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function add_entry()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "<fieldset><legend>".$this->T_("Blog module - add new entry")."</legend>";
		$this->draw_form_tag("blog","process_add_entry","page=".$this->page_id,array(),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Title").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmTitle\" size=\"80\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Body").":</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea name=\"ta\" id=\"ta\" style=\"width: 99%; height: 300px;\"></textarea></td>\n";
		echo "</tr>\n";
		echo "</tr><td colspan=\"2\">\n";
		echo "<button type=\"submit\">".$this->T_("Add")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		echo "</fieldset>\n";
	}
}

function date_mysql2php($mysql_date)
{
	$length = strlen ($mysql_date);
	if ($length==7)
	{
		// YYYY-MM
		$year = substr($mysql_date,0,4);
		$month = substr($mysql_date,5,2);
		$timestamp = mktime(0,0,0,$month,1,$year);
		return date("F Y",$timestamp);
	}
	else if ($length == 19)
	{
		// YYYY-MM-DD HH:MM:SS
		$year = substr($mysql_date,0,4);
		$month = substr($mysql_date,5,2);
		$day = substr($mysql_date,8,2);
		$hour = substr($mysql_date,11,2);
		$minute = substr($mysql_date,14,2);
		$second = substr($mysql_date,17,2);
		$timestamp = mktime($hour,$minute,$second,$month,$day,$year);
		return date("l jS of F Y H:i:s T",$timestamp);
	}
	else
		return $mysql_date;
}

function date_mysql2timestamp($mysql_date)
{
	$length = strlen ($mysql_date);
	if ($length == 19)
	{
		// YYYY-MM-DD HH:MM:SS
		$year = substr($mysql_date,0,4);
		$month = substr($mysql_date,5,2);
		$day = substr($mysql_date,8,2);
		$hour = substr($mysql_date,11,2);
		$minute = substr($mysql_date,14,2);
		$second = substr($mysql_date,17,2);
		$timestamp = mktime($hour,$minute,$second,$month,$day,$year);
		return $timestamp;
	}
	else
		return $mysql_date;
}


function show_archives()
{
	require_once ("config.php");
	global $db;
	echo "<h3>".$this->T_("Blog module - archives")."</h3>\n";
	$months = $db->get_results ("SELECT DISTINCT LEFT( date_created, 7 ) AS month FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' ORDER BY month DESC");
	if (is_array($months))
	{
		foreach ($months as $month)
		{
		   	echo "<p><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_month_archive&amp;month=".$month->month."\">".$this->date_mysql2php($month->month)."</a></p>\n";
		}
	}
	else
	{
		echo "<p>".$this->T_("The Blog contains no posts")."</p>\n";
	}
}

function show_month_archive()
{
	require_once ("config.php");
	global $db;

	echo "<h3>".$this->T_("Blog module")." - ".$this->T_("Archive for")." ".$this->date_mysql2php($this->clean_get['month'])."</h3>\n";
	echo "<h4>\n";
   	echo "[<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_archives\">".$this->T_("Archives")."</a>]\n";
	echo " [<a href=\"modules/blog/rss_2_0_".$this->box_id.".xml\">".$this->T_("RSS")."</a>]\n";
	echo " [<a href=\"modules/blog/atom_0_3_".$this->box_id.".xml\">".$this->T_("Atom")."</a>]\n";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "["; $this->draw_edit_link($this->T_("Add post"),"blog","add_entry",null); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Blog settings"),"blog","display_blog_settings",null); echo "]\n";
	}
	echo "</h4>\n";
	$this->test_error();

	$posts = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' AND LEFT(date_created,7)='".$db->quote($this->clean_get['month'])."' ORDER BY date_modified DESC LIMIT 10");
	if(is_array($posts))
	{
		foreach ($posts as $post)
		{
			echo "<br/><h3><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_single_entry&amp;post_id=".$post->post_id."\">".stripslashes($post->title)."</a></h3>\n";
			echo "<div class=\"frame\">".stripslashes($post->content)."</div>\n";
			echo "<h4>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
				echo "["; $this->draw_edit_link($this->T_("Edit"),"blog","edit_entry",null,array("post_id" => $post->post_id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete"),"blog","process_delete_entry",null,array("post_id" => $post->post_id)); echo "]";
			}
			echo ("<br/>".$this->T_("Posted")." ".$this->date_mysql2php($post->date_created));
			echo ("<br/>Modified ".$this->date_mysql2php($post->date_modified));
			echo "</h4>\n";
			$blog_settings = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
			if (!$blog_settings)
			{
				$blog_settings->allow_comments = 1;
			}
			if ($blog_settings->allow_comments == 1)
			{
				// Display comments and add coment link
				$comments = $db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blog_comments WHERE post_id='".$db->quote($post->post_id)."'");
				echo "<h4>".$comments." ".$this->T_ngettext("comment","comments",$comments)."</h4>\n";
			}
			echo "<hr />\n";
		}
	}
	else
	{
		echo "<p>".$this->T_("The Blog contains no posts")."</p>\n";
	}
}



function show_single_entry()
{
	require_once ("config.php");
	global $db;

	echo "<h4>\n";
   	echo "[<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_archives\">".$this->T_("Archives")."</a>]\n";
	echo " [<a href=\"modules/blog/rss_2_0_".$this->box_id.".xml\">".$this->T_("RSS")."</a>]\n";
	echo " [<a href=\"modules/blog/atom_0_3_".$this->box_id.".xml\">".$this->T_("Atom")."</a>]\n";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "["; $this->draw_edit_link($this->T_("Add post"),"blog","add_entry",null); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Blog settings"),"blog","display_blog_settings",null); echo "]\n";
	}
	echo "</h4>\n";
	$this->test_error();

	$posts = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blog_posts WHERE post_id='".$db->quote($this->clean_get['post_id'])."' LIMIT 1");
	if(is_array($posts))
	{
		foreach ($posts as $post)
		{
			echo "<br/><h3><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_single_entry&amp;post_id=".$post->post_id."\">".stripslashes($post->title)."</a></h3>\n";
			echo "<div class=\"frame\">".stripslashes($post->content)."</div>\n";
			echo "<h4>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
				echo "["; $this->draw_edit_link($this->T_("Edit"),"blog","edit_entry",null,array("post_id" => $post->post_id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete"),"blog","process_delete_entry",null,array("post_id" => $post->post_id)); echo "]";
			}
			echo ("<br/>".$this->T_("Posted")." ".$this->date_mysql2php($post->date_created));
			echo ("<br/>Modified ".$this->date_mysql2php($post->date_modified));
			echo "</h4>\n";
			$blog_settings = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
			if (!$blog_settings)
			{
				$blog_settings->allow_comments = 1;
			}
			if ($blog_settings->allow_comments == 1)
			{
				// Display comments and add coment link
				echo "<br/><h3>".$this->T_("Comments")."</h3>\n";
				$comments = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blog_comments WHERE post_id='".$db->quote($post->post_id)."'");
				if (is_array($comments))
				{
					foreach ($comments as $comment)
					{
						echo "<h4>".$comment->name.", ".$this->date_mysql2php($comment->date_posted),"</h4>\n";
						echo "<p>".$comment->comment."</p>\n";
						if ($this->access_level >= XHP_ACCESS_EDIT)
						{
                            echo "<h4>\n";
							echo "["; $this->draw_edit_link($this->T_("Edit"),"blog","edit_comment",null,array("post_id" => $post->post_id, "comment_id" => $comment->id)); echo "]\n";
							echo "["; $this->draw_action_link($this->T_("Delete"),"blog","process_delete_comment",null,array("comment_id" => $comment->id, "post_id" => $post->post_id)); echo "]";
							echo "</h4>\n";
						}
						echo "<hr />";
					}
				}
				else
					echo "<p>".$this->T_("No comments")."</p>\n";
				echo "<h4>["; $this->draw_edit_link($this->T_("Add comment"),"blog","add_comment",null,array("post_id" => $post->post_id)); echo "]</h4>\n";
			}
		}
	}
	else
	{
		echo "<p>".$this->T_("The Blog contains no posts")."</p>\n";
	}
}

function display_blog_settings()
{
	require_once ("config.php");
	global $db;
	echo "<fieldset><legend><img align=\"absmiddle\" src=\"modules/users/site_settings.gif\" alt=\"".$this->T_("Blog settings")."\" />".$this->T_("Blog settings")."</legend>\n";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$blog = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
		$settings_exist = 1;
		if (!$blog)
		{
			$blog->title = "";
			$blog->image_url = "";
			$blog->description = "";
			$blog->allow_comments = 1;
			$settings_exist = 0;
		}
		echo "<script language=\"javascript\">\n";
		echo "function showselectimage()\n";
		echo "{\n";
		echo "window.open('inc/htmlarea/plugins/ImageManager/managerxhp.php','selectimagedialog','toolbar=no,menubar=no,personalbar=no,width=10,height=10,scrollbars=no,resizable=yes,modal=yes,dependable=yes');\n";
		echo "}\n";
		echo "</script>\n";
		$this->draw_form_tag ("blog", "process_blog_settings", "page=".$this->page_id, array(),true);
		echo "<table>\n";
		echo "<tr><td>".$this->T_("Blog title").":</td><td><input type=\"text\" size=\"60\" name=\"frmBlogTitle\" value=\"".stripslashes($blog->title)."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Blog image URL").":</td><td><input type=\"text\" size=\"60\" name=\"frmBlogImageUrl\" id=\"frmBlogImageUrl\" value=\"".$blog->image_url."\"/>\n";
		echo "<br/><a href=\"javascript:showselectimage();\">".$this->T_("Select blog image")."</a>\n";
		echo "</td></tr>\n";
		echo "<tr><td>".$this->T_("Blog description").":</td><td><input type=\"text\" size=\"60\" name=\"frmBlogDescription\" value=\"".stripslashes($blog->description)."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Allow comments").":</td><td>\n";
		echo "<select name=\"frmBlogAllowComments\">\n";
		echo "<option value=\"yes\""; if ($blog->allow_comments==1) echo " selected"; echo ">".$this->T_("Yes")."</option>\n";
		echo "<option value=\"no\""; if ($blog->allow_comments==0) echo " selected"; echo ">".$this->T_("No")."</option>\n";
		echo "</select>\n";
		echo "</td></tr>\n";
		echo "<tr><td colspan=\"2\"><input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\"/></td></tr>\n";
		echo "</table>\n";
		echo "<input type=\"hidden\" name=\"frmSettingsExist\" value=\"".$settings_exist."\" />\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function add_comment()
{
	require_once ("config.php");
	global $db;
	echo "<fieldset><legend>".$this->T_("Add comment")."</legend>\n";
	$this->draw_form_tag ("blog","process_new_comment","page=".$this->page_id."&box_id=".$this->box_id."&action=show_single_entry&post_id=".$this->clean_get['post_id'],array("post_id" => $this->clean_get['post_id']),true);
	echo "<table>\n";
	echo "<tr>\n";
	echo "<td>".$this->T_("Name").":</td>\n";
	echo "<td><input type=\"text\" name=\"frmName\" size=\"80\"/></td>\n";
	echo "</tr>\n";
	echo "<td colspan=\"2\">".$this->T_("Comments").":</td></tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\">\n";
	echo "<textarea name=\"frmCommentText\" cols=\"60\" rows=\"10\"></textarea></td></tr>\n";
	echo "<tr><td colspan=\"2\">\n";
	echo "<button class=\"submit\" type=\"submit\">".$this->T_("Add")."</button>\n";
	echo "</td></tr>\n";
	echo "</table>\n";
	echo "</form>\n";
	echo "</fieldset>\n";
}

function edit_comment()
{
	require_once ("config.php");
	global $db;
	echo "<fieldset><legend><img align=\"absmiddle\" src=\"modules/users/site_settings.gif\" alt=\"".$this->T_("Edit comment")."\" />".$this->T_("Edit comment")."</legend>\n";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$this->draw_form_tag ("blog","process_edit_comment","page=".$this->page_id."&box_id=".$this->box_id."&action=show_single_entry&post_id=".$this->clean_get['post_id'],array("comment_id" => $this->clean_get['comment_id']),true);
		$comment = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blog_comments WHERE id='".$db->quote($this->clean_get['comment_id'])."'");
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Name").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmName\" value=\"".$comment->name."\" size=\"80\"/></td>\n";
		echo "</tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Comment").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea name=\"ta\" cols=\"60\" rows=\"10\">".strip_tags($comment->comment)."</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

// End display functions

// Data processing functions
function process_edit_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		if ($db->query ("UPDATE ".XHP_TBL_PREFIX."blog_posts SET title='".$db->quote($this->clean_post['frmTitle'])."', content='".$db->quote($this->clean_post['ta'])."', date_modified=NOW() WHERE post_id='".$db->quote($this->clean_get['post_id'])."'") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			$this->generate_feeds();
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}

function process_blog_settings()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$allow_comments = 1;
		if ($this->clean_post['frmBlogAllowComments']=="no")
			$allow_comments = 0;
		$query = "";
		if ($this->clean_post['frmSettingsExist']==1)
			$query = "UPDATE ".XHP_TBL_PREFIX."blog_settings SET title='".$db->quote($this->clean_post['frmBlogTitle'])."', description='".$db->quote($this->clean_post['frmBlogDescription'])."', image_url='".$db->quote($this->clean_post['frmBlogImageUrl'])."', allow_comments='".$db->quote($allow_comments)."' WHERE box_id='".$db->quote($this->box_id)."'";
		else
			$query = "INSERT INTO ".XHP_TBL_PREFIX."blog_settings SET title='".$db->quote($this->clean_post['frmBlogTitle'])."', description='".$db->quote($this->clean_post['frmBlogDescription'])."', image_url='".$this->clean_post['frmBlogImageUrl']."', box_id='".$db->quote($this->box_id)."', allow_comments='".$db->quote($allow_comments)."'";

		if ($db->query ($query) !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			$this->generate_feeds();
			return 0;
		}
		else
			return mysql_error();
	}
	else
		return $this->T_("Not authorized");
}

function process_add_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		if ($db->query ("INSERT INTO ".XHP_TBL_PREFIX."blog_posts SET date_created=NOW(), box_id='".$db->quote($this->box_id)."', date_modified=NOW(), title='".$db->quote($this->clean_post['frmTitle'])."', content='".$db->quote($this->clean_post['ta'])."', poster_id=1") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			$this->generate_feeds();
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}

function process_delete_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		// delete any comments associated to this post
		$db->query ("DELETE FROM ".XHP_TBL_PREFIX."blog_comments WHERE post_id='".$db->quote($this->clean_get['post_id'])."'");

		if ($db->query ("DELETE FROM ".XHP_TBL_PREFIX."blog_posts WHERE post_id='".$db->quote($this->clean_get['post_id'])."'") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}

function process_delete_comment()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		if ($db->query ("DELETE FROM ".XHP_TBL_PREFIX."blog_comments WHERE id='".$db->quote($this->clean_get['comment_id'])."'") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}

function process_new_comment()
{
	// Output is not allowed here!!!!
	// TODO: maybe we shouldn't allow adding a new comment here 
	// if the module settings don't allow comments
	require_once ("config.php");
	global $db;
	if ($db->query ("INSERT INTO ".XHP_TBL_PREFIX."blog_comments SET date_posted=NOW(), post_id='".$db->quote($this->clean_get['post_id'])."', name='".$db->quote($this->clean_post['frmName'])."', comment='".$db->quote($this->nls_and_urls($this->clean_post['frmCommentText']))."'") !== false)
	{
		// Action functions must return an error code that can be used
		// by display functions
		return 0;
	}
	else
	{
		return mysql_error();
	}
}

function process_edit_comment()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		if ($db->query ("UPDATE ".XHP_TBL_PREFIX."blog_comments SET name='".$db->quote($this->clean_post['frmName'])."', comment='".$db->quote($this->nls_and_urls($this->clean_post['ta']))."' WHERE id='".$db->quote($this->clean_get['comment_id'])."'") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}


// End data processing functions

function generate_feeds()
{
	require_once ("config.php");
	global $db;
	require_once("modules/blog/feedcreator.class.php");

    $blog_settings = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."blog_settings WHERE box_id='".$db->quote($this->box_id)."'");
	if (!$blog_settings)
	{
		$blog_settings->title = "";
		$blog_settings->image_url = "";
		$blog_settings->description = "";
	}

	$rss = new UniversalFeedCreator();
	//$rss->useCached(); // use cached version if age<1 hour
	$rss->title = $blog_settings->title;
	$rss->description = $blog_settings->description;

	//optional
	//$rss->descriptionTruncSize = 500;
	$rss->descriptionHtmlSyndicated = true;

	$rss->link = XHP_C_PAGE_URL."index.php?page=".$this->page_id;
	// this seems to be needed only for RSS 1.0 and we're not interested in it
	// $rss->syndicationURL = "http://www.changeme.com/".$_SERVER["PHP_SELF"];

	$image = new FeedImage();
	$image->title = $blog_settings->title;
	$image->url = $blog_settings->image_url;
	$image->link = XHP_C_PAGE_URL."index.php?page=".$this->page_id;
	$image->description = $blog_settings->description;

	//optional
	//$image->descriptionTruncSize = 500;
	$image->descriptionHtmlSyndicated = true;

	$rss->image = $image;

	// get your news items from somewhere, e.g. your database:
	$posts = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."blog_posts WHERE box_id='".$db->quote($this->box_id)."' ORDER BY date_modified DESC LIMIT 10");
	if (is_array($posts))
	{
		foreach ($posts as $post)
		{
			$item = new FeedItem();
		    $item->title = $post->title;
		    $item->link = XHP_C_PAGE_URL."index.php?page=".$this->page_id."&box_id=".$this->box_id."&action=show_single_entry&post_id=".$post->post_id;
		    $item->description = $post->content;

		    //optional
		    //$item->descriptionTruncSize = 500;
		    $item->descriptionHtmlSyndicated = true;

		    $item->date = $this->date_mysql2timestamp($post->date_created);
		    $item->source = XHP_C_PAGE_URL;
		    $author = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."users WHERE id='".$db->quote($post->poster_id)."'");
		    $item->author = $author->first_name." ".$author->last_name;

		    $rss->addItem($item);
		}
	}

	// valid format strings are: RSS0.91, RSS1.0, RSS2.0, PIE0.1 (deprecated),
	// MBOX, OPML, ATOM, ATOM0.3, HTML, JS
	$rss->saveFeed("RSS2.0", "modules/blog/rss_2_0_".$this->box_id.".xml",false);
	$rss->saveFeed("ATOM0.3", "modules/blog/atom_0_3_".$this->box_id.".xml",false);
}

}
?>
