<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

// This module needs configuration:
// - refresh time
// - number of items displayed
// - properties displayed(and what items - title, date, source, description)
// - maximum number of characters for description
// - layout


require_once ("inc/xhp_module.inc.php");
class xhp_blogroll extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "show_single_entry";
	$this->valid_actions[] = "process_delete_comment";
	$this->valid_actions[] = "process_delete_feed";
	$this->valid_actions[] = "display_manage_feeds";
	$this->valid_actions[] = "display_blogroll_settings";
	$this->valid_actions[] = "edit_comment";
	$this->valid_actions[] = "add_comment";
	$this->valid_actions[] = "display_blogroll_edit_feed";
	$this->valid_actions[] = "process_add_feed";
	$this->valid_actions[] = "process_close_page";
	$this->valid_actions[] = "process_update_feed";
	$this->valid_actions[] = "process_blogroll_settings";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['item_id'] must be a valid item id
	if (isset($_GET['item_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blogroll_items WHERE id='".$db->quote($_GET['item_id'])."'")>0)
			$this->clean_get['item_id'] = $_GET['item_id'];
	}

	// $_GET['feed_id'] must be a valid feed id
	if (isset($_GET['feed_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE id='".$db->quote($_GET['feed_id'])."'")>0)
			$this->clean_get['feed_id'] = $_GET['feed_id'];
	}
	
	// TODO: These are textboxes. They should be some kind of validation for them.
	// $_POST['frmDisplayTitle'] doesn't have constraints
	if (isset($_POST['frmDisplayTitle']))
		$this->clean_post['frmDisplayTitle'] = $_POST['frmDisplayTitle'];

	// $_POST['frmDisplayDate'] doesn't have constraints
	if (isset($_POST['frmDisplayDate']))
		$this->clean_post['frmDisplayDate'] = $_POST['frmDisplayDate'];

	// $_POST['frmDisplayDescription'] doesn't have constraints
	if (isset($_POST['frmDisplayDescription']))
		$this->clean_post['frmDisplayDescription'] = $_POST['frmDisplayDescription'];

	// $_POST['frmDisplaySource'] doesn't have constraints
	if (isset($_POST['frmDisplaySource']))
		$this->clean_post['frmDisplaySource'] = $_POST['frmDisplaySource'];

	// $_POST['frmSettingsExist'] must be 0 or 1
	if (isset($_POST['frmSettingsExist']))
		if ($_POST['frmSettingsExist']==1)
			$this->clean_post['frmSettingsExist'] = 1;
		else
			$this->clean_post['frmSettingsExist'] = 0;

	// $_POST['frmNumberOfItems'] must be a number > 0
	if (isset($_POST['frmNumberOfItems']))
		if (is_numeric($_POST['frmNumberOfItems']))
			if ($_POST['frmNumberOfItems']>0)
				$this->clean_post['frmNumberOfItems'] = $_POST['frmNumberOfItems'];

	// $_POST['frmMaxCharacters'] must be a number > 0
	if (isset($_POST['frmMaxCharacters']))
		if (is_numeric($_POST['frmMaxCharacters']))
			if ($_POST['frmMaxCharacters']>0)
				$this->clean_post['frmMaxCharacters'] = $_POST['frmMaxCharacters'];

	// $_POST['frmColumns'] must be a number > 0
	if (isset($_POST['frmColumns']))
		if (is_numeric($_POST['frmColumns']))
			if ($_POST['frmColumns']>0)
				$this->clean_post['frmColumns'] = $_POST['frmColumns'];

	// $_POST['frmUrl'] must be a URL
	// TODO: make the URL chesk
	if (isset($_POST['frmUrl']))
		$this->clean_post['frmUrl'] = $_POST['frmUrl'];
												
	// $_POST['frmRefreshInterval'] must be a number > 0
	if (isset($_POST['frmRefreshInterval']))
		if (is_numeric($_POST['frmRefreshInterval']))
			if ($_POST['frmRefreshInterval']>0)
				$this->clean_post['frmRefreshInterval'] = $_POST['frmRefreshInterval'];

		
}


function delete_instance()
{
	require_once ("config.php");
	global $db;
	// delete generated feed
	@unlink("modules/blogroll/rss_1_0_".$this->box_id.".xml");
	$feeds = $db->get_results ("SELECT DISTINCT id FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($feeds))
	{
		foreach ($feeds as $feed)
		{
			$this->delete_feed($feed->id);
		}
	}
	$query = "DELETE FROM ".XHP_TBL_PREFIX."blogroll_settings WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
}

function delete_module()
{
	require_once ("config.php");
	global $db;
		
	// delete tables
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blogroll_feeds";
	$db->query ($query);
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blogroll_items";
	$db->query ($query);
	$query = "DROP TABLE ".XHP_TBL_PREFIX."blogroll_settings";
	$db->query ($query);
}


function change_headers()
{
	// redefine function change_headers
	
	global $db;
	// add live bookmark to the feed of this blog
	$blogroll_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($this->page_id)."'");
	$this->set_header("live_bookmark","<link rel=\"alternate\" type=\"application/rss+xml\" title=\"".$blogroll_title."\" href=\"modules/blogroll/rss_1_0_".$this->box_id.".xmll\">\n");

		
	if (isset($this->clean_get['action']))
	{
		// only change headers for archives and single entries
		switch ($this->clean_get['action'])
		{
			case "show_single_entry":
				$title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."blogroll_items WHERE id='".$db->quote($this->clean_get['item_id'])."'");
				$this->set_header("title","<title>".$title." - ".XHP_C_PAGE_TITLE."</title>\n");
				break;
			default:
				break;
		}
	}
	// call the base function we are extending
	xhp_module::change_headers();
}


function draw_module()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "<h3>".$this->T_("Blogroll")."</h3>";
		echo "<h4>\n";
		echo "["; $this->draw_edit_link($this->T_("Manage feeds"),"blogroll","display_manage_feeds",null); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Blogroll settings"),"blogroll","display_blogroll_settings",null); echo "]\n";
	}
	echo " [<a href=\"modules/blogroll/rss_1_0_".$this->box_id.".xml\">".$this->T_("RSS")."</a>]\n";
	echo "</h4>\n";

	$this->test_error();
	
	$this->update_feeds();

	$feeds = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($feeds))
	{
		$feed_no = 0;
		$where_string = "AND (";
		foreach ($feeds as $feed)
		{
			if ($feed_no == 0)
			{
				$where_string .= " feed_id='".$db->quote($feed->id)."'";
			}
			else
			{
				$where_string .= " OR feed_id='".$db->quote($feed->id)."'";
			}
			$feed_no++;
		}
		$where_string .= ") ";

		$query = "SELECT ".XHP_TBL_PREFIX."blogroll_items.*, ".XHP_TBL_PREFIX."blogroll_feeds.title AS feed_title, ".XHP_TBL_PREFIX."blogroll_feeds.link AS feed_link FROM ".XHP_TBL_PREFIX."blogroll_items, ".XHP_TBL_PREFIX."blogroll_feeds WHERE ".XHP_TBL_PREFIX."blogroll_items.feed_id=".XHP_TBL_PREFIX."blogroll_feeds.id ".$where_string." ORDER BY date_timestamp DESC";
		$items = $db->get_results ($query);
		if (is_array($items))
		{
			$settings = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_settings WHERE box_id='".$db->quote($this->box_id)."'");
			$displayed_items = 0;
			$drawn_columns = 0;
			if ($settings->columns_no < 1)
				$settings->columns_no = 1;
			$column_width = 100/$settings->columns_no;
			echo "<table width=\"100%\"><tr>\n";
			foreach ($items as $item)
			{
				$original_item = unserialize($item->item_object);
				//echo "<pre>"; print_r($original_item); echo "</pre>";
				if ($drawn_columns==$settings->columns_no)
				{
					echo "</tr><tr>";
					$drawn_columns = 0;
				}
				echo "<td class=\"blogroll_item\" valign=\"top\" width=\"".$column_width."%\">\n";
				// Display item
				if ($settings->display_title == 1)
				{
					if ($item->title == "")
						$item_title = $this->T_("No title");
					else
						$item_title = $item->title;

					if (strpos($item->link,XHP_C_PAGE_URL."index.php?title=")===false)
						echo "<div class=\"blogroll_item_title\"><a href=\"index.php?title=".urlencode($item_title)."&amp;page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_single_entry&amp;item_id=".$item->id."\">".$item_title." </a></div>\n";
					else
						echo "<div class=\"blogroll_item_title\"><a href=\"".$item->link."\">".$item_title." </a></div>\n";
				}
				if ($settings->display_date == 1)
					echo "<div class=\"blogroll_item_date\">".date("j M Y H:i:s",$item->date_timestamp)."</div>\n";
				$feed_source = $item->feed_link;
				$feed_creator = $item->feed_title;
				if (isset($original_item['dc']['source']))
					$feed_source = $original_item['dc']['source'];
				if (isset($original_item['dc']['creator']))
					$feed_creator = $original_item['dc']['creator'];
				if (isset($original_item['dc']['author']))
					$feed_source = $original_item['dc']['author'];
				if (isset($original_item['dc']['publisher']))
					$feed_creator = $original_item['dc']['publisher'];

				/*
				if (isset($original_item['dc']))
				{
					$feed_source = $original_item['dc']['source'];
					$feed_creator = $original_item['dc']['creator'];
				}
				*/
				if ($settings->display_source == 1)
					echo "<div class=\"blogroll_feed_title\">".$this->T_("From").": <a href=\"".$feed_source."\">".$feed_creator."</a></div>\n";
				if ($settings->display_description == 1)
					echo "<div class=\"blogroll_item_description\">".substr(strip_tags($item->description),0,$settings->max_characters)."</div>\n";
				//echo "<hr/>";
				echo "</td>\n";
				$drawn_columns++;
				$displayed_items++;
				if ($displayed_items==$settings->number_of_items)
					break;
			}
           	echo "</tr></table>\n";
		}
	}

}


function show_single_entry()
{
	require_once ("config.php");
	global $db;

	echo "<h4>\n";
   	echo "[<a href=\"index.php?page=".$this->page_id."\">".$this->T_("Article index")."</a>]\n";
	echo "</h4>\n";
	$this->test_error();

	$query = "SELECT ".XHP_TBL_PREFIX."blogroll_items.*, ".XHP_TBL_PREFIX."blogroll_feeds.title AS feed_title, ".XHP_TBL_PREFIX."blogroll_feeds.link AS feed_link FROM ".XHP_TBL_PREFIX."blogroll_items, ".XHP_TBL_PREFIX."blogroll_feeds WHERE ".XHP_TBL_PREFIX."blogroll_items.id='".$db->quote($this->clean_get['item_id'])."' AND ".XHP_TBL_PREFIX."blogroll_items.feed_id=".XHP_TBL_PREFIX."blogroll_feeds.id LIMIT 1";
	$items = $db->get_results ($query);
	if (is_array($items))
	{
		$settings = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_settings WHERE box_id='".$db->quote($this->box_id)."'");
		$displayed_items = 0;
		$drawn_columns = 0;
		$column_width = 100/$settings->columns_no;
		echo "<table width=\"100%\"><tr>\n";
		foreach ($items as $item)
		{
			$original_item = unserialize($item->item_object);
			//echo "<pre>"; print_r($original_item); echo "</pre>";
			if ($drawn_columns==$settings->columns_no)
			{
				echo "</tr><tr>";
				$drawn_columns = 0;
			}
			echo "<td class=\"blogroll_item\" valign=\"top\" width=\"".$column_width."%\">\n";

			// Display item
			if ($item->title == "")
				$item_title = $this->T_("No title");
			else
				$item_title = $item->title;
			echo "<h1><div class=\"blogroll_item_title\"><a href=\"".$item->link."\">".$item_title." </a></div></h1>\n";

			echo "<div class=\"blogroll_item_date\">".date("j M Y H:i:s",$item->date_timestamp)."</div>\n";

			$feed_source = $item->feed_link;
			$feed_creator = $item->feed_title;
			if (isset($original_item['dc']['source']))
				$feed_source = $original_item['dc']['source'];
			if (isset($original_item['dc']['creator']))
				$feed_creator = $original_item['dc']['creator'];
			if (isset($original_item['dc']['author']))
				$feed_source = $original_item['dc']['author'];
			if (isset($original_item['dc']['publisher']))
				$feed_creator = $original_item['dc']['publisher'];

			echo "<div class=\"blogroll_feed_title\">".$this->T_("From").": <a href=\"".$feed_source."\">".$feed_creator."</a></div>\n";

			echo "<div class=\"blogroll_item_description\">".strip_tags($item->description)."</div>\n";

			echo "<h1><div class=\"blogroll_item_details\"><a href=\"".$item->link."\">".$this->T_("Details...")."</a></div></h1>\n";



			$blogroll_settings = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_settings WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
			if (!$blogroll_settings)
			{
				$blogroll_settings->allow_comments = 1;
			}
			if ($blogroll_settings->allow_comments == 1)
			{
				// Display comments and add coment link
				echo "<br/><h3>".$this->T_("Comments")."</h3>\n";
				$comments = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_comments WHERE post_id='".$db->quote($post->post_id)."'");
				if (is_array($comments))
				{
					foreach ($comments as $comment)
					{
						echo "<h4>".$comment->name.", ".$this->date_mysql2php($comment->date_posted),"</h4>\n";
						echo "<p>".$comment->comment."</p>\n";
						if ($this->access_level >= XHP_ACCESS_EDIT)
						{
                            echo "<h4>\n";
							echo "["; $this->draw_edit_link($this->T_("Edit"),"blogroll","edit_comment",null,array("post_id" => $post->post_id, "comment_id" => $comment->id)); echo "]\n";
							echo "["; $this->draw_action_link($this->T_("Delete"),"blogroll","process_delete_comment",null,array("comment_id" => $comment->id, "post_id" => $post->post_id)); echo "]";
							echo "</h4>\n";
						}
						echo "<hr />";
					}
				}
				else
					echo "<p>".$this->T_("No comments")."</p>\n";
				echo "<h4>["; $this->draw_edit_link($this->T_("Add comment"),"blogroll","add_comment",null,array("post_id" => $post->post_id)); echo "]</h4>\n";
			}

			echo "</td>\n";
			$drawn_columns++;
			$displayed_items++;
			if ($displayed_items==$settings->number_of_items)
				break;
		}
       	echo "</tr></table>\n";
	}
}


function update_feeds()
{
	require_once ("config.php");
	require_once ("inc/magpierss/rss_fetch.inc.php");
	define (MAGPIE_CACHE_ON,false);
	define (MAGPIE_DEBUG,false);
	define (MAGPIE_OUTPUT_ENCODING,"UTF-8");
	define (MAGPIE_DETECT_ENCODING,true);
	global $db;
	$feeds = $db->get_results ("SELECT *, NOW()-last_refresh AS age FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($feeds))
	{
		foreach ($feeds as $feed)
		{
			// the age is returned in seconds
			if ($feed->age > $feed->refresh_interval)
			//if (true)
			{
				// refetch feed
				$feed_source = fetch_rss($feed->url);
				if (is_array($feed_source->items))
				{
					// we reverse the array in order to insert the entries from the oldest to the newest
					$items = array_reverse($feed_source->items);
					foreach ($items as $item)
					{
						$serialization = serialize($item);
						$item_md5 = md5($serialization);
						if ($item['date_timestamp']==0)
						{
							$item['date_timestamp'] = time();
						}
						$db_items = $db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."blogroll_items WHERE item_md5='".$db->quote($item_md5)."' AND feed_id='".$db->quote($feed->id)."'");
						if ($db_items == 0)
						{
							// The item is not in the database and must be added now
							$db->query ("INSERT INTO ".XHP_TBL_PREFIX."blogroll_items SET item_object='".$db->quote($serialization)."', item_md5='".$db->quote($item_md5)."', feed_id='".$db->quote($feed->id)."', description='".$db->quote($item['description'])."', date_timestamp='".$db->quote($item['date_timestamp'])."', title='".$db->quote($item['title'])."', link='".$db->quote($item['link'])."'");
						}
					}
				}
				$db->query ("UPDATE ".XHP_TBL_PREFIX."blogroll_feeds SET last_refresh=NOW(), title='".$db->quote($feed_source->channel['title'])."', link='".$db->quote($feed_source->channel['link'])."' WHERE id='".$db->quote($feed->id)."'");
			}
		}
	}
	$this->generate_feeds();
}

function display_manage_feeds()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$feeds = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE box_id='".$db->quote($this->box_id)."'");
		if (is_array($feeds))
		{
			echo "<fieldset>\n";
			echo "<legend>".$this->T_("manage_feeds")."</legend>";
			echo "<table>\n";
			foreach ($feeds as $feed)
			{
				echo "<tr>\n";
				echo "<td>".$feed->url."</td>\n";
				echo "<td>".$feed->refresh_interval."</td>\n";
				echo "<td>"; $this->draw_edit_link($this->T_("Edit"),"blogroll","display_blogroll_edit_feed",null,array("feed_id" => $feed->id)); echo "</td>\n";
				echo "<td>"; $this->draw_action_link($this->T_("Delete"),"blogroll","process_delete_feed",null,array("feed_id" => $feed->id)); echo "</td>\n";
				echo "</tr>\n";
			}
			echo "</table>\n";
			echo "</fieldset>\n";
		}
		echo "<fieldset>\n";
		echo "<legend>".$this->T_("Add feed")."</legend>";
		$this->draw_form_tag("blogroll","process_add_feed",null,array());
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("URL").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmUrl\" size=\"80\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Refresh interval").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmRefreshInterval\" size=\"80\" /></td>\n";
		echo "</tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Add")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		echo "</fieldset>\n";
        echo "<br/>\n";
		$this->draw_form_tag ("blogroll","process_close_page","page=".$this->page_id,array(),true);
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Close")."</button>\n";
		echo "</form>\n";

	}
}

function display_blogroll_edit_feed()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$feed = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE id='".$db->quote($this->clean_get['feed_id'])."'");
		echo "<fieldset>\n";
		echo "<legend>".$this->T_("Update")."</legend>";
		$this->draw_form_tag("blogroll","process_update_feed","module=blogroll&action=display_manage_feeds&page=".$this->page_id."&box_id=".$this->box_id,array("feed_id" => $this->clean_get['feed_id']));
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("URL").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmUrl\" size=\"80\" value=\"".$feed->url."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Refresh interval").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmRefreshInterval\" size=\"80\" value=\"".$feed->refresh_interval."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		echo "</fieldset>\n";
        echo "<br/>\n";
		$this->draw_form_tag ("blogroll","process_close_page","page=".$this->page_id,array(),true);
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Close")."</button>\n";
		echo "</form>\n";

	}
}


function process_close_page()
{
	return 0;
}

function display_blogroll_settings()
{
	echo "<fieldset>\n";
	echo "<legend>".$this->T_("Blogroll settings")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$settings = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_settings WHERE box_id='".$db->quote($this->box_id)."'");
		$settings_exist = 1;
		if (!$settings)
			$settings_exist = 0;
		$this->draw_form_tag ("blogroll","process_blogroll_settings","page=".$this->page_id,array(),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Number of items").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmNumberOfItems\" size=\"10\" value=\"".$settings->number_of_items."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Maximum characters").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmMaxCharacters\" size=\"10\" value=\"".$settings->max_characters."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Columns").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmColumns\" size=\"10\" value=\"".$settings->columns_no."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Display title").":</td>\n";
		echo "<td><input type=\"checkbox\" name=\"frmDisplayTitle\" ";
		if ($settings->display_title == 1)
			echo "checked";
		echo " /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Display date").":</td>\n";
		echo "<td><input type=\"checkbox\" name=\"frmDisplayDate\" ";
		if ($settings->display_date == 1)
			echo "checked";
		echo " /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Display description").":</td>\n";
		echo "<td><input type=\"checkbox\" name=\"frmDisplayDescription\" ";
		if ($settings->display_description == 1)
			echo "checked";
		echo " /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Display source").":</td>\n";
		echo "<td><input type=\"checkbox\" name=\"frmDisplaySource\" ";
		if ($settings->display_source == 1)
			echo "checked";
		echo " /></td>\n";
		echo "</tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "<input type=\"hidden\" name=\"frmSettingsExist\" value=\"".$settings_exist."\" />\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function process_blogroll_settings()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$display_tile = 0;
	if (isset($this->clean_post['frmDisplayTitle']))
		if ($this->clean_post['frmDisplayTitle'] == "on")
			$display_tile = 1;
	$display_date = 0;
	if (isset($this->clean_post['frmDisplayDate']))
		if ($this->clean_post['frmDisplayDate'] == "on")
			$display_date = 1;
	$display_description = 0;
	if (isset($this->clean_post['frmDisplayDescription']))
		if ($this->clean_post['frmDisplayDescription'] == "on")
			$display_description = 1;
	$display_source = 0;
	if (isset($this->clean_post['frmDisplaySource']))
		if ($this->clean_post['frmDisplaySource'] == "on")
			$display_source = 1;

	if ($this->clean_post['frmSettingsExist']==1)
	{
		$db->query ("UPDATE ".XHP_TBL_PREFIX."blogroll_settings SET "
			."number_of_items='".$db->quote($this->clean_post['frmNumberOfItems'])."',"
			."max_characters='".$db->quote($this->clean_post['frmMaxCharacters'])."',"
			."columns_no='".$db->quote($this->clean_post['frmColumns'])."',"
			."display_title='".$db->quote($display_tile)."',"
			."display_date='".$db->quote($display_date)."',"
			."display_description='".$db->quote($display_description)."',"
			."display_source='".$db->quote($display_source)."' "
			."WHERE box_id='".$db->quote($this->box_id)."'");
	}
	else
	{
		$db->query ("INSERT INTO ".XHP_TBL_PREFIX."blogroll_settings SET "
			."number_of_items='".$db->quote($this->clean_post['frmNumberOfItems'])."',"
			."max_characters='".$db->quote($this->clean_post['frmMaxCharacters'])."',"
			."columns_no='".$db->quote($this->clean_post['frmColumns'])."',"
			."display_title='".$db->quote($display_tile)."',"
			."display_date='".$db->quote($display_date)."',"
			."display_description='".$db->quote($display_description)."',"
			."display_source='".$db->quote($display_source)."',"
			."box_id='".$db->quote($this->box_id)."'");
	}

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function process_add_feed()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	if (!isset($this->clean_post['frmUrl']))
		return $this->T_("Invalid URL.");
	if (!isset($this->clean_post['frmRefreshInterval']))
		return $this->T_("Invalid refresh interval.");
	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."blogroll_feeds SET url='".$db->quote($this->clean_post['frmUrl'])
		."',refresh_interval='".$db->quote($this->clean_post['frmRefreshInterval'])
		."', box_id='".$db->quote($this->box_id)."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_update_feed()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	if (!isset($this->clean_post['frmUrl']))
		return $this->T_("Invalid URL.");
	if (!isset($this->clean_post['frmRefreshInterval']))
		return $this->T_("Invalid refresh interval.");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."blogroll_feeds SET url='".$db->quote($this->clean_post['frmUrl'])
		."',refresh_interval='".$db->quote($this->clean_post['frmRefreshInterval'])
		."' WHERE id='".$db->quote($this->clean_get['feed_id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function process_delete_feed()
{
	// Output is not allowed here!!!!
	// Action functions must return an error code that can be used
	// by display functions
	return delete_feed($this->clean_get['feed_id']);
}

function delete_feed($feed_id)
{
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE id='".$db->quote($feed_id)."'");
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."blogroll_items WHERE feed_id='".$db->quote($feed_id)."'");
	return 0;
}

function generate_feeds()
{
	require_once ("config.php");
	global $db;
	require_once("modules/blog/feedcreator.class.php");

	$page_title = $db->get_var ("SELECT title FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($this->page_id)."' LIMIT 1");


	$rss = new UniversalFeedCreator();
	//$rss->useCached(); // use cached version if age<1 hour
	$rss->title = $page_title;
	$rss->description = $page_title;

	//optional
	//$rss->descriptionTruncSize = 500;
	$rss->descriptionHtmlSyndicated = true;

	$rss->link = XHP_C_PAGE_URL."index.php?page=".$this->page_id;
	// this seems to be needed only for RSS 1.0 and we're not interested in it
	// $rss->syndicationURL = "http://www.changeme.com/".$_SERVER["PHP_SELF"];

	$feeds = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."blogroll_feeds WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($feeds))
	{
		$feed_no = 0;
		$where_string = "AND (";
		foreach ($feeds as $feed)
		{
			if ($feed_no == 0)
			{
				$where_string .= " feed_id='".$db->quote($feed->id)."'";
			}
			else
			{
				$where_string .= " OR feed_id='".$db->quote($feed->id)."'";
			}
			$feed_no++;
		}
		$where_string .= ") ";

		$query = "SELECT ".XHP_TBL_PREFIX."blogroll_items.*, ".XHP_TBL_PREFIX."blogroll_feeds.title AS feed_title, ".XHP_TBL_PREFIX."blogroll_feeds.link AS feed_link FROM ".XHP_TBL_PREFIX."blogroll_items, ".XHP_TBL_PREFIX."blogroll_feeds WHERE ".XHP_TBL_PREFIX."blogroll_items.feed_id=".XHP_TBL_PREFIX."blogroll_feeds.id ".$where_string." ORDER BY date_timestamp DESC LIMIT 50";
		$items = $db->get_results ($query);
		if (is_array($items))
		{
			foreach ($items as $item)
			{
				$newitem = new FeedItem();

				$original_item = unserialize($item->item_object);

			    $newitem->title = $original_item['title'];
				if (strpos($original_item['link'],XHP_C_PAGE_URL."index.php?title=")===false)
					$newitem->link = XHP_C_PAGE_URL."index.php?title=".urlencode($item->title)."&amp;page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=show_single_entry&amp;item_id=".$item->id;
				else
			    	$newitem->link = $original_item['link'];
			    $newitem->description = $original_item['description'];
			    $newitem->descriptionHtmlSyndicated = true;

			    $newitem->date = intval($item->date_timestamp + date("Z"));
				$feed_source = $item->feed_link;
				$feed_creator = $item->feed_title;
				if (isset($original_item['dc']['source']))
					$feed_source = $original_item['dc']['source'];
				if (isset($original_item['dc']['creator']))
					$feed_creator = $original_item['dc']['creator'];
				if (isset($original_item['dc']['author']))
					$feed_source = $original_item['dc']['author'];
				if (isset($original_item['dc']['publisher']))
					$feed_creator = $original_item['dc']['publisher'];
				/*
				if (isset($original_item['dc']))
				{
					$feed_source = $original_item['dc']['source'];
					$feed_creator = $original_item['dc']['creator'];
				}
				*/
			    $newitem->source = $feed_source;
			    $newitem->author = $feed_creator;

			    $rss->addItem($newitem);
			}
		}
	}
	// valid format strings are: RSS0.91, RSS1.0, RSS2.0, PIE0.1 (deprecated),
	// MBOX, OPML, ATOM, ATOM0.3, HTML, JS
	$rss->saveFeed("RSS1.0", "modules/blogroll/rss_1_0_".$this->box_id.".xml",false);
	//$rss->saveFeed("ATOM0.3", "modules/blogroll/atom_0_3_".$this->box_id.".xml",false);
}


} // class end
?>
