<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_content extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "process_change_type";
	$this->valid_actions[] = "process_edit";
	$this->valid_actions[] = "display_edit_content";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['type'] must be 0 or 1
	if (isset($_GET['type']))
	{
		if (($_GET['type']==0)||($_GET['type']==1))
			$this->clean_get['type'] = $_GET['type'];
	}
	
	// $_POST['ta'] doesn't have constraints
	// TODO: This more about this! ;-)
	if (isset($_POST['ta']))
		$this->clean_post['ta'] = $_POST['ta'];
		
	// $_POST['frmContentType'] must be 0 or 1
	if (isset($_POST['frmContentType']))
	{
		if ($_POST['frmContentType'] == 0)
			$this->clean_post['frmContentType'] = 0;
		else if ($_POST['frmContentType'] == 1)
			$this->clean_post['frmContentType'] = 1;
	}
	
}


function delete_instance()
{
	require_once ("config.php");
	global $db;
	$query = "DELETE FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
}

function delete_module()
{
	require_once ("config.php");
	global $db;
	$query = "DROP TABLE ".XHP_TBL_PREFIX."content";
	$db->query ($query);
}


function change_headers()
{
	// redefine function change_headers
	require_once ("config.php");
	global $errcode;
	global $db;
    $htmlcontent = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
    if ($htmlcontent->type == 0)
		return xhp_module::change_headers();


	if (isset($this->clean_get['action']))
	{
		// only change headers for archives and single entries
		switch ($this->clean_get['action'])
		{
			case "display_edit_content":
				// add htmlarea script in header
				$htmlarea = "<script type=\"text/javascript\">\n"
					."_editor_url = \"inc/htmlarea/\";\n"
					."_editor_lang = \"en\";\n"
					."</script>\n"
					."<script type=\"text/javascript\" src=\"inc/htmlarea/htmlarea.js\"></script>\n"
					."<script type=\"text/javascript\">\n"
					//."//<![CDATA[\n"
					."HTMLArea.loadPlugin(\"ImageManager\");\n"
					."HTMLArea.loadPlugin(\"FileManager\");\n"
					."var editor = null;\n"
					."initdocument = function () {\n"
					."editor = new HTMLArea(\"ta\");\n"
					."editor.registerPlugin(FileManager);\n"
					."editor.generate();\n"
					."}\n"
					."function addEvent(obj, evType, fn)\n"
					."{\n"
					."if (obj.addEventListener) { obj.addEventListener(evType, fn, true); return true; }\n"
					."else if (obj.attachEvent) {  var r = obj.attachEvent(\"on\"+evType, fn);  return r;  }\n"
					."else {  return false; }\n"
					."}\n"
					."addEvent(window, 'load', initdocument);\n"
					//."//]]>\n"
					."</script>\n";
				$this->set_header("htmlarea",$htmlarea);
			default:
				break;
		}
	}
	// call the base function we are extending
	xhp_module::change_headers();
}


// Internal functions
function nls_and_urls($ret)
{
	$ret = ' ' . $ret;
	// matches an "xxxx://yyyy" URL at the start of a line, or after a space.
	// xxxx can only be alpha characters.
	// yyyy is anything up to the first space, newline, comma, double quote or <
	$ret = preg_replace("#([\t\r\n ])([a-z0-9]+?){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a href="\2://\3" target="_blank">\2://\3</a>', $ret);

	// matches a "www|ftp.xxxx.yyyy[/zzzz]" kinda lazy URL thing
	// Must contain at least 2 dots. xxxx contains either alphanum, or "-"
	// zzzz is optional.. will contain everything up to the first space, newline,
	// comma, double quote or <.
	$ret = preg_replace("#([\t\r\n ])(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a href="http://\2.\3" target="_blank">\2.\3</a>', $ret);
	// matches an email@domain type address at the start of a line, or after a space.
	// Note: Only the followed chars are valid; alphanums, "-", "_" and or ".".
	$ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);

	// Remove our padding..
	$ret = substr($ret, 1);
	return nl2br($ret);
}
// End module internal functions

function draw_module()
{
	require_once ("config.php");
	global $errcode;
	global $db;

	// Test error code if coming from action function
	if (isset($errcode) and ($errcode!=0))
	{
		// An error occured in the action function
		// User is notified here
		echo "<p>Error: ".$errcode."</p>\n";
	}

    $htmlcontent = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");

    if ($htmlcontent == null)
    {
    	// no content yet for this instance
    	// initialize content
    	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."content SET name='Content', content='', box_id='".$db->quote($this->box_id)."'");
	    $htmlcontent = $db->get_var ("SELECT * FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
    }

	if ($this->access_level >= XHP_ACCESS_EDIT)
    {
	    // Content name
	    echo "<h3>".$htmlcontent->name."</h3>\n";
		echo "<h4>["; $this->draw_edit_link($this->T_("Edit"),"content","display_edit_content",null); echo "]</h4>\n";
    }

    // Output content
    echo $htmlcontent->content;
}

function display_edit_content()
{
	require_once ("config.php");
	global $errcode;
	global $db;

	// Test error code if coming from action function
	if (isset($errcode) and ($errcode!=0))
	{
		// An error occured in the action function
		// User is notified here
		echo "<p>Error: ".$errcode."</p>\n";
	}

	//echo "here";
    $htmlcontent = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");

    if ($htmlcontent == null)
    {
    	// no content yet for this instance
    	// initialize content
    	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."content SET name='Content', content='', box_id='".$db->quote($this->box_id)."'");
	    $htmlcontent = $db->get_var ("SELECT * FROM ".XHP_TBL_PREFIX."content WHERE box_id='".$db->quote($this->box_id)."' LIMIT 1");
    }

    // Content name
    echo "<h3>".$htmlcontent->name."</h3>\n";

	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
        // draw type selector
        $this->draw_form_tag("content","process_change_type",null);
		echo "<select name=\"frmContentType\">\n";
		echo "<option value=\"0\" ";
		if ($htmlcontent->type==0)
			echo "selected";
		echo ">Plain text</option>\n";
		echo "<option value=\"1\" ";
		if ($htmlcontent->type==1)
			echo "selected";
		echo ">HTML</option>\n";
		echo "</select>\n";
        echo "<input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\" />\n";
        echo "</form>\n";
		echo "<br /><fieldset><legend>".$this->T_("Edit this page")." - ";
		if ($htmlcontent->type==0)
		{
			echo $this->T_("Plain text")."</legend>\n";
		}
		else
		{
			echo $this->T_("HTML")."</legend>\n";
		}


		$this->draw_form_tag("content","process_edit","page=".$this->page_id,array("type" => $htmlcontent->type),true);
		echo "<textarea id=\"ta\" name=\"ta\" style=\"width: 99%; height: 300px;\" >\n";
		// Drop page content here
		if ($htmlcontent->type==1)
		{
			// HTML
			echo $htmlcontent->content;
		}
		else
		{
			// plain text
			echo strip_tags(stripslashes($htmlcontent->content));
		}
		echo "</textarea></fieldset>\n";
		echo "<p />\n";
		echo "<input type=\"submit\" class=\"submit\" name=\"ok\" value=\"".$this->T_("Update Page")."\" />\n";
		echo "</form>\n";
	}
}


function process_edit()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$content = $this->clean_post['ta'];

	if ($this->clean_get['type']!=1)
	{
		// plain text - must be formatted
		$content = $this->nls_and_urls($content);
	}

	$content = $db->quote($content);

	$query = "UPDATE ".XHP_TBL_PREFIX."content SET content='".$content."' WHERE box_id='".$db->quote($this->box_id)."'";
	//echo $query; die();
    $db->query($query);
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_change_type()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$query = "UPDATE ".XHP_TBL_PREFIX."content SET type='".$db->quote($this->clean_post['frmContentType'])."' WHERE box_id='".$db->quote($this->box_id)."'";
	//echo $query; die();
    $db->query($query);
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


} // end class
?>
