<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_engine extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "process_move_module_to_box";
	$this->valid_actions[] = "display_move_to_box";
	$this->valid_actions[] = "process_add_module_to_box";
	$this->valid_actions[] = "update_module_orders";
	$this->valid_actions[] = "process_delete_module_from_box";
	$this->valid_actions[] = "process_make_main_module";
	$this->valid_actions[] = "process_move_module_up";
	$this->valid_actions[] = "process_move_module_down";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation

	require_once ("inc/engine_security.inc.php");
	global $clean_post, $clean_get, $clean_cookie;
	$this->clean_get['page_id'] = $clean_get['page_id'];
	$this->clean_get['box_id'] = $clean_get['box_id'];
		
	// $_GET['box_name'] should be safe; it's defined in theme
	// maybe in future we should create a box list when uploading a theme
	if (isset($_GET['box_name']))
	{
		$this->clean_get['box_name'] = $_GET['box_name'];
	}
	
	// $_GET['frmModule'] must be a valid module id
	if (isset($_POST['frmModule']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."modules WHERE module_id='".$db->quote($_POST['frmModule'])."'")>0)
			$this->clean_post['frmModule'] = $_POST['frmModule'];
	}
		
	// $_GET['frmPage'] must be a valid page id
	if (isset($_POST['frmPage']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($_POST['frmPage'])."'")>0)
			$this->clean_post['frmPage'] = $_POST['frmPage'];
	}
	
	// TODO: we have no way of checking valid boxes as of now, so we'll just consider this one safe
	$this->clean_post['frmBox'] = $_POST['frmBox'];

}


function draw_module()
{
	echo "<h3 style=\"text-align: left;\">\n";
	echo $this->T_("The module has not been called correctly!");
	echo "</h3>\n";
}

function display_move_to_box()
{
	echo "<fieldset><legend>".$this->T_("Move module to another box")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$this->draw_form_tag("engine","process_move_module_to_box","page=".$this->page_id,array(),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Page Name").":</td>\n";
		echo "<td><select name=\"frmPage\">\n";
		$pages = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."pages ORDER BY parent_id ASC, menu_order ASC");
		if (is_array($pages))
		{
			foreach ($pages as $page)
			{
				echo "<option value=\"".$page->page_id."\" ";
				if ($page->page_id == $this->page_id)
					echo "selected";
				echo ">".$page->title."</option>\n";
			}
		}
		echo "</select>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Box name").":</td>\n";
		echo "<td><select name=\"frmBox\">\n";
		$boxes = $db->get_results("SELECT DISTINCT name FROM ".XHP_TBL_PREFIX."boxes");
		if (is_array($boxes))
		{
			foreach ($boxes as $box)
			{
				echo "<option value=\"".$box->name."\">".$box->name."</option>\n";
			}
		}
		echo "</select>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function process_add_module_to_box()
{
	// Output is not allowed here!!!!
	if (!isset($this->clean_post['frmModule']))
		return "No such module";
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");

	$old_order = $db->get_var ("SELECT MAX(module_order) FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($this->clean_get['page_id'])."'");
	$module_order = $old_order + 1;
	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."boxes SET name='".$db->quote($this->clean_get['box_name'])
		."',page_id='".$db->quote($this->clean_get['page_id'])."', module_id='".$db->quote($this->clean_post['frmModule'])."', module_order='".$db->quote($module_order)."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_move_module_to_box()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$box_name = $db->get_var ("SELECT name FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->box_id)."' LIMIT 1");

	$max_module_order = $db->get_var ("SELECT MAX(module_order) FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($this->clean_post['frmPage'])."' AND name='".$db->quote($this->clean_post['frmBox'])."'");
	$max_module_order++;
    $db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET name='".$db->quote($this->clean_post['frmBox'])."', page_id='".$db->quote($this->clean_post['frmPage'])."', module_order='".$db->quote($max_module_order)."', main_module=0 WHERE id='".$db->quote($this->box_id)."'");

    // update module orders in the old page
    $this->update_module_orders($this->page_id,$box_name);

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function update_module_orders($page_id,$box_name)
{
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$modules = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($page_id)."' AND name='".$db->quote($box_name)."' ORDER BY module_order ASC");
	if (is_array($modules))
	{
		$order = 0;
		foreach ($modules as $module)
		{
			$order++;
			$query = "UPDATE ".XHP_TBL_PREFIX."boxes SET module_order='".$db->quote($order)."' WHERE id='".$db->quote($module->id)."'";
			$db->query ($query);
		}
	}
}


function process_delete_module_from_box()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$box_name = $db->get_var ("SELECT name FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->clean_get['box_id'])."' LIMIT 1");
	$module_id = $db->get_var ("SELECT module_id FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->clean_get['box_id'])."' LIMIT 1");
		
	// initialize module object
	require_once ("modules/".$module_id."/".$module_id.".xhpm.php");
	$classname = "xhp_".$module_id;
	$objmodule = new $classname($module_id,$this->clean_get['box_id'],$this->clean_get['page_id'],$this->access_level);
	//$objmodule->box_id = $this->clean_get['box_id'];
	//$objmodule->page_id = $this->clean_get['page_id'];
	$objmodule->delete_instance();
	

	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->clean_get['box_id'])."'");
	$this->update_module_orders($this->page_id,$box_name);
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_make_main_module()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET main_module='0' WHERE page_id='".$db->quote($this->clean_get['page_id'])."'");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET main_module='1' WHERE id='".$db->quote($this->clean_get['box_id'])."'");

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_move_module_up()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$current_module = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->clean_get['box_id'])."' LIMIT 1");

	// if this is not the first module
	if ($current_module->module_order > 1)
	{
		$previous_order = $current_module->module_order - 1;
		$previous_module = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($this->clean_get['page_id'])."' AND name='".$db->quote($current_module->name)."' AND module_order='".$db->quote($previous_order)."' LIMIT 1");

		if ($previous_module != null)
		{
			// previous module exists
			$previous_module->module_order = $current_module->module_order;
			$current_module->module_order = $previous_order;
			// update database
			$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET module_order='".$db->quote($current_module->module_order)."' WHERE id='".$db->quote($current_module->id)."'");
			$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET module_order='".$db->quote($previous_module->module_order)."' WHERE id='".$db->quote($previous_module->id)."'");
		}
	}

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_move_module_down()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$current_module = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE id='".$db->quote($this->clean_get['box_id'])."' LIMIT 1");

	$max_module_order = $db->get_var ("SELECT MAX(module_order) FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($this->clean_get['page_id'])."' AND name='".$db->quote($current_module->name)."'");

	// if this is not the first module
	if ($current_module->module_order < $max_module_order)
	{
		$next_order = $current_module->module_order + 1;
		$next_module = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($this->clean_get['page_id'])."' AND name='".$db->quote($current_module->name)."' AND module_order='".$db->quote($next_order)."' LIMIT 1");
		if ($next_module != null)
		{
			// next module exists
			$next_module->module_order = $current_module->module_order;
			$current_module->module_order = $next_order;
			// update database
			$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET module_order='".$db->quote($current_module->module_order)."' WHERE id='".$db->quote($current_module->id)."'");
			$db->query ("UPDATE ".XHP_TBL_PREFIX."boxes SET module_order='".$db->quote($next_module->module_order)."' WHERE id='".$db->quote($next_module->id)."'");
		}
	}

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


} // class end

?>
