<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_gallery extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "display_album";
	$this->valid_actions[] = "process_delete_album";
	$this->valid_actions[] = "display_big_picture";
	$this->valid_actions[] = "process_delete_picture";
	$this->valid_actions[] = "process_move_picture_up";
	$this->valid_actions[] = "process_move_picture_down";
	$this->valid_actions[] = "process_make_album_thumbnail";
	$this->valid_actions[] = "display_create_album";
	$this->valid_actions[] = "edit_album_description";
	$this->valid_actions[] = "display_upload_picture";
	$this->valid_actions[] = "display_upload_picture_archive";
	$this->valid_actions[] = "display_album_settings";
	$this->valid_actions[] = "edit_picture_description";
	$this->valid_actions[] = "process_new_album";
	$this->valid_actions[] = "process_new_picture";
	$this->valid_actions[] = "process_upload_zip";
	$this->valid_actions[] = "process_album_settings";
	$this->valid_actions[] = "process_edit_album_description";
	$this->valid_actions[] = "process_edit_picture_description";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['album_id'] must be a valid album id
	if (isset($_GET['album_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($_GET['album_id'])."'")>0)
			$this->clean_get['album_id'] = $_GET['album_id'];
	}
	
	// $_GET['picture_id'] must be a valid picture id
	if (isset($_GET['picture_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($_GET['picture_id'])."'")>0)
			$this->clean_get['picture_id'] = $_GET['picture_id'];
	}

	// $_POST['frmName'] doesn't have constraints
	if (isset($_POST['frmName']))
		$this->clean_post['frmName'] = $_POST['frmName'];

	// $_POST['frmDescription'] doesn't have constraints
	if (isset($_POST['frmDescription']))
		$this->clean_post['frmDescription'] = $_POST['frmDescription'];
		
	// $_POST['frmResampleTo'] must be a number > 0
	if (isset($_POST['frmResampleTo']))
		if (is_numeric($_POST['frmResampleTo']))
			if ($_POST['frmResampleTo']>0)
				$this->clean_post['frmResampleTo'] = $_POST['frmResampleTo'];

	// $_POST['frmThumbnailColumns'] must be a number > 0
	if (isset($_POST['frmThumbnailColumns']))
		if (is_numeric($_POST['frmThumbnailColumns']))
			if ($_POST['frmThumbnailColumns']>0)
				$this->clean_post['frmThumbnailColumns'] = $_POST['frmThumbnailColumns'];
				
	// $_POST['frmDefaultAlbum'] doesn't have constraints
	// TODO: this is a checkbox... treat it right
	if (isset($_POST['frmDefaultAlbum']))
		$this->clean_post['frmDefaultAlbum'] = $_POST['frmDefaultAlbum'];
				


}


function delete_instance()
{
	require_once ("config.php");
	global $db;
	$albums = $db->get_results ("SELECT DISTINCT id FROM ".XHP_TBL_PREFIX."gallery_albums WHERE box_id='".$db->quote($this->box_id)."'");
	if (is_array($albums))
	{
		foreach ($albums as $album)
		{
			$this->delete_album($album->id);
		}
	}
}

function delete_module()
{
	require_once ("config.php");
	global $db;
	// delete content from all instances first
	$albums = $db->get_results ("SELECT DISTINCT id FROM ".XHP_TBL_PREFIX."gallery_albums");
	if (is_array($albums))
	{
		foreach ($albums as $album)
		{
			$this->delete_album($album->id);
		}
	}
	
	// delete tables
	$query = "DROP TABLE ".XHP_TBL_PREFIX."gallery_pictures";
	$db->query ($query);
	$query = "DROP TABLE ".XHP_TBL_PREFIX."gallery_albums";
	$db->query ($query);
	
}


function draw_module()
{
	require_once ("config.php");
	global $db;

	echo "<h3>".$this->T_("Photo Gallery - Albums")."</h3>";

	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "<h4>["; $this->draw_edit_link($this->T_("Create new album"),"gallery","display_create_album",null); echo "]</h4>\n";
	}


	$this->test_error();
	
	// If we have a default album, display that one instead of displaying album list
	$query = "SELECT * FROM ".XHP_TBL_PREFIX."gallery_albums WHERE box_id='".$db->quote($this->box_id)."' AND default_album='1' LIMIT 1";
	$albums = $db->get_results ($query);
	if (is_array($albums))
	{
		$album = $albums[0];
		$this->show_pictures_from_album($album->id);
		if ($this->access_level >= XHP_ACCESS_EDIT)
		{
			echo "<h4>".$this->T_("Hint: If you want to display album list instead of pictures from this album in the module, go to album settings and uncheck Default album.")."</h4>\n";
		}
		return;
	}

	// No default album, display album list
	$query = "SELECT * FROM ".XHP_TBL_PREFIX."gallery_albums WHERE box_id='".$db->quote($this->box_id)."' ORDER BY id DESC";
	$albums = $db->get_results ($query);
	if (is_array($albums))
	{
		foreach ($albums as $album)
		{
			echo "<br /><h3>".stripslashes($album->name)."</h3>\n";
			echo "<div class=\"frame\"><table><tr><td width=\"170px\">\n";
			// Thumbnail of the latest picture here
			$thumbnail_id = $db->get_var ("SELECT thumbnail_id FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($album->id)."'");
			$thumbnail_id = $db->get_var ("SELECT id FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($thumbnail_id)."'");
			if ($thumbnail_id != null)
		    	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_album&amp;album_id=".$album->id."\"><img src=\"albums/album_".$album->id."/thumbnail_".$thumbnail_id.".png\" width=\"150\" alt=\"".$this->T_("Thumbnail")."\" /></a>\n";
			else
			{
				// the album is empty or the thumbnail id is bogus
				// try to get the first picture of the album
				$thumbnail_id = $db->get_var ("SELECT id FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE album_id='".$db->quote($album->id)."' ORDER BY DISPLAY_ORDER ASC LIMIT 1");
				if ($thumbnail_id != null)
			    	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_album&amp;album_id=".$album->id."\"><img src=\"albums/album_".$album->id."/thumbnail_".$thumbnail_id.".png\" width=\"150\" alt=\"".$this->T_("Thumbnail")."\" /></a>\n";
				else
			    	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_album&amp;album_id=".$album->id."\"><img src=\"images/emptyalbum.png\" width=\"150\" alt=\"".$this->T_("Thumbnail")."\" /></a>\n";
			}

			echo "</td><td>".stripslashes($album->description)."</td></tr></table></div>\n";
			echo "<h4>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
				echo "["; $this->draw_edit_link($this->T_("Edit Album Name/Description"),"gallery","edit_album_description",null,array("album_id" => $album->id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete Album"),"gallery","process_delete_album",null,array("album_id" => $album->id)); echo "]\n";
			}
			echo "</h4>\n";
		}
	}
}

function display_create_album()
{
	echo "<fieldset><legend>".$this->T_("Create new album")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$this->draw_form_tag("gallery","process_new_album","page=".$this->page_id,array(),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Name").":</td>\n";
		echo "<td><input class=\"textbox\" type=\"text\" name=\"frmName\" size=\"80\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea class=\"textbox\" name=\"frmDescription\" cols=\"60\" rows=\"10\"></textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Create new album")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function display_upload_picture()
{
	echo "<fieldset><legend>".$this->T_("Upload new picture")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$this->draw_form_tag("gallery","process_new_picture","page=".$this->page_id."&box_id=".$this->box_id."&action=display_album&album_id=".$this->clean_get['album_id'],array("album_id" => $this->clean_get['album_id']),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Name").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmName\" class=\"textbox\" size=\"40\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Image file").":</td>\n";
		echo "<td><input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"100000000\" />\n";
		echo "<input type=\"file\" class=\"textbox\" name=\"frmFile\" size=\"40\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Resample to:")."</td>\n";
		echo "<td>\n";
		echo "<select class=\"textbox\" name=\"frmResampleTo\">\n";
		echo "<option value=\"none\">".$this->T_("No resample")."</option>\n";
		echo "<option value=\"600px\" selected>600px</option>\n";
		echo "<option value=\"800px\">800px</option>\n";
		echo "</select>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea class=\"textbox\" name=\"frmDescription\" cols=\"50\" rows=\"10\"></textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Upload new picture")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function display_upload_picture_archive()
{
	echo "<fieldset><legend>".$this->T_("Upload picture archive")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		// Upload several pictures as zip
		$this->draw_form_tag("gallery","process_upload_zip","page=".$this->page_id."&box_id=".$this->box_id."&action=display_album&album_id=".$this->clean_get['album_id'],array("album_id" => $this->clean_get['album_id']),true);
		echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"100000000\" />\n";
		echo "<input type=\"file\" class=\"textbox\" name=\"frmFile\" size=\"40\" /><br />\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Upload picture archive")."</button>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function display_album_settings()
{
	echo "<fieldset><legend>".$this->T_("Album settings")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		// Album settings
		$query = "SELECT thumbnail_columns FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($this->clean_get['album_id'])."' LIMIT 1";
		$thumbnail_columns = $db->get_var ($query);
		$this->draw_form_tag("gallery","process_album_settings","page=".$this->page_id."&box_id=".$this->box_id."&action=display_album&album_id=".$this->clean_get['album_id'],array("album_id" => $this->clean_get['album_id']),true);
		echo "<table>\n";
		echo "<tr><td>".$this->T_("Thumbnail columns:")."</td><td><input type=\"text\" class=\"textbox\" name=\"frmThumbnailColumns\" value=\"".$thumbnail_columns."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Default album")."</td><td><input type=\"checkbox\" class=\"textbox\" name=\"frmDefaultAlbum\" ";
		$query = "SELECT default_album FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($this->clean_get['album_id'])."' LIMIT 1";
		$default_album = $db->get_var ($query);
		if ($default_album == 1)
			echo "checked";
		echo " /></td></tr>\n";
		echo "<tr><td></td><td><button type=\"submit\" class=\"submit\">".$this->T_("Update")."</button></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function edit_album_description()
{
	echo "<fieldset><legend>".$this->T_("Gallery - Edit Album Name/Description")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$album = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($this->clean_get['album_id'])."'");
		$this->draw_form_tag ("gallery","process_edit_album_description","page=".$this->page_id,array("album_id" => $this->clean_get['album_id']),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Name").":</td>\n";
		echo "<td><input class=\"textbox\" type=\"text\" name=\"frmName\" size=\"80\" value=\"".strip_tags(stripslashes($album->name))."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea class=\"textbox\" name=\"frmDescription\" cols=\"60\" rows=\"10\">".strip_tags(stripslashes($album->description))."</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function edit_picture_description()
{
	echo "<fieldset><legend>".$this->T_("Photo Gallery - Edit Picture Name/Description")."</legend>";
	require_once ("config.php");
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		global $db;
		$picture = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($this->clean_get['picture_id'])." LIMIT 1'");
		$this->draw_form_tag("gallery","process_edit_picture_description","page=".$this->page_id."&box_id=".$this->box_id."&action=display_album&album_id=".$picture->album_id,array("picture_id" => $picture->id),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Name").":</td>\n";
		echo "<td><input class=\"textbox\" type=\"text\" name=\"frmName\" size=\"40\" value=\"".stripslashes($picture->name)."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea class=\"textbox\" name=\"frmDescription\" cols=\"50\" rows=\"10\">".strip_tags(stripslashes($picture->description))."</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		echo "</fieldset>\n";
	}
}


function display_album()
{
	$this->show_pictures_from_album($this->clean_get['album_id']);
}

function show_pictures_from_album($album_id)
{
	echo "<h3>".$this->T_("Photo Gallery Album")."</h3>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "<h4>\n";
		echo "["; $this->draw_edit_link($this->T_("Upload new picture"),"gallery","display_upload_picture",null,array("album_id" => $album_id)); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Upload picture archive"),"gallery","display_upload_picture_archive",null,array("album_id" => $album_id)); echo "]\n";
		echo "["; $this->draw_edit_link($this->T_("Album settings"),"gallery","display_album_settings",null,array("album_id" => $album_id)); echo "]\n";
		echo "</h4>\n";
	}


	$pictures = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE album_id='".$db->quote($album_id)."' ORDER BY display_order ASC, id DESC");
	if (!is_array($pictures))
		$pictures = array();
	$drawn_columns = 0;
	$query = "SELECT thumbnail_columns FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($album_id)."'";
	$thumbnail_columns = $db->get_var ($query);

	echo "<table width=\"100%\"><tr>\n";
	foreach ($pictures as $picture)
	{
		if ($drawn_columns==$thumbnail_columns)
		{
			echo "</tr><tr>";
			$drawn_columns = 0;
		}
		echo "<td valign=\"top\"><br /><h3>".stripslashes($picture->name)."</h3>\n";
		echo "<div class=\"frame\">\n";
		// Thumbnail of the picture here
    	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_big_picture&amp;picture_id=".$picture->id."\"><img src=\"albums/album_".$album_id."/thumbnail_".$picture->id.".png\" width=\"150\" alt=\"".$this->T_("Thumbnail")."\" /></a>\n";
		echo "<br />".stripslashes($picture->description)."</div>\n";
		echo "<h4>\n";
		if ($this->access_level >= XHP_ACCESS_EDIT)
		{
			echo "["; $this->draw_edit_link($this->T_("Edit Picture Name/Description"),"gallery","edit_picture_description",null,array("picture_id" => $picture->id)); echo "]\n";
            echo "["; $this->draw_action_link($this->T_("Delete Picture"),"gallery","process_delete_picture",null,array("picture_id" => $picture->id, "album_id" => $picture->album_id)); echo "]";
			echo "<br />[";  $this->draw_action_link ($this->T_("Move picture up"),"gallery","process_move_picture_up",null,array("picture_id" => $picture->id, "album_id" => $picture->album_id)); echo "]";
			echo "<br />[";  $this->draw_action_link ($this->T_("Move picture down"),"gallery","process_move_picture_down",null,array("picture_id" => $picture->id, "album_id" => $picture->album_id)); echo "]";
			echo "<br />[";  $this->draw_action_link ($this->T_("Make album thumbnail"),"gallery","process_make_album_thumbnail",null,array("picture_id" => $picture->id, "album_id" => $picture->album_id)); echo "]";
		}
		echo "</h4></td>\n";
		$drawn_columns++;
	}
	echo "</tr></table>\n";
}

function display_big_picture()
{
	require_once ("config.php");
	global $db;
	$query = "SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id ='".$db->quote($this->clean_get['picture_id'])."'";
	$picture = $db->get_row ($query);
	$album_id = $picture->album_id;
    $prev_picture = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE album_id='".$db->quote($album_id)."' AND display_order<'".$db->quote($picture->display_order)."' ORDER BY display_order DESC LIMIT 1");
    $next_picture = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE album_id='".$db->quote($album_id)."' AND display_order>'".$db->quote($picture->display_order)."' ORDER BY display_order ASC LIMIT 1");

	echo "<br/><h3>".stripslashes($picture->name)."</h3>\n";
	echo "<div class=\"frame\" align=\"center\">\n";
	echo "<img src=\"albums/album_".$album_id."/picture_".$picture->id.".png\" alt=\".\" />\n";
	echo "<p style=\"text-align: left;\">".stripslashes($picture->description)."</p>\n";
   	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_album&amp;album_id=".$picture->album_id."\">".$this->T_("Back to album")."</a><br/>\n";

    if ($prev_picture != null)
    {
    	// link to the previous picture
	   	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_big_picture&amp;picture_id=".$prev_picture->id."\">".$this->T_("Previous:")." ".stripslashes($prev_picture->name)."</a>\n";
    }

    if ($next_picture != null)
    {
    	// link to the next picture
	   	echo "<a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_big_picture&amp;picture_id=".$next_picture->id."\">".$this->T_("Next:")." ".stripslashes($next_picture->name)."</a>\n";
    }
    echo "</div>\n";
}


function process_new_album()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."gallery_albums SET name='".$db->quote($this->clean_post['frmName'])
		."', description='".nl2br($db->quote($this->clean_post['frmDescription']))."', box_id='".$db->quote($this->box_id)."'");
	$album_id = $db->insert_id;
	if (!(mkdir("albums/album_".$album_id,0777)))
	{
		// Directory creation failed; delete entry from database
		$db->query ("DELETE FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($album_id)."'");
	}
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_delete_album()
{
	// Output is not allowed here!!!!
	// Action functions must return an error code that can be used
	// by display functions
	return $this->delete_album($this->clean_get['album_id']);
}

function delete_album($album_id)
{
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."gallery_albums WHERE id='".$db->quote($album_id)."'");
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE album_id='".$db->quote($album_id)."'");
	$dir = "albums/album_".$album_id;
	if (is_writable($dir))
	{
		if (is_dir($dir))
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
					if (($file!=".")&&($file!=".."))
						unlink ($dir."/".$file);
				closedir($dh);
			}
		}
		rmdir ("albums/album_".$album_id);
	}
	else
		return "Album directory is not writable";
}

function process_edit_album_description()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET name='".$db->quote($this->clean_post['frmName'])
		."', description='".nl2br($db->quote($this->clean_post['frmDescription']))
		."' WHERE id='".$db->quote($this->clean_get['album_id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_edit_picture_description()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	global $db;
	$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_pictures SET name='".$db->quote($this->clean_post['frmName'])
		."', description='".nl2br($db->quote($this->clean_post['frmDescription']))
		."' WHERE id='".$db->quote($this->clean_get['picture_id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function add_picture_to_album($name,$description,$album_id,$image_file)
{
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");

    $picture_order = $db->get_var("SELECT MAX( display_order ) FROM `".XHP_TBL_PREFIX."gallery_pictures` WHERE album_id='".$db->quote($album_id)."'");
    if ($picture_order == null)
        $picture_order = 0;
    else
        $picture_order++;

	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."gallery_pictures SET name='".$db->quote($name)
		."', description='".nl2br($db->quote($description))."', album_id='".$db->quote($album_id)
		."', date_taken=now(), display_order='".$db->quote($picture_order)."'");
	$picture_id = $db->insert_id;
	$image_processed_ok = true;

	$size = getimagesize($image_file);
	$image_width = $size[0];
	switch ($this->clean_post['frmResampleTo'])
	{
		case "none":
			$new_width = $image_width;
			break;
		case "600px":
			$new_width = 600;
			break;
		case "800px":
			$new_width = 800;
			break;
		default:
			$new_width = 600;
			break;
	}
	$image_height = $size[1];
	$image_type = $size[2];
	$thumbnail_height = 150*$image_height/$image_width;
	$newimage_height = $new_width*$image_height/$image_width;
	switch ($image_type)
	{
		case 2:
			// JPEG
			$uploaded_image = imagecreatefromjpeg ($image_file);
			if ($uploaded_image)
			{
				$thumbnail = imagecreatetruecolor(150,$thumbnail_height);
				imagecopyresampled ( $thumbnail, $uploaded_image, 1, 1, 0, 0, 148, $thumbnail_height-2, $image_width, $image_height);
				imagepng ($thumbnail, "albums/album_".$album_id."/thumbnail_".$picture_id.".png");
				$newimage = imagecreatetruecolor($new_width,$newimage_height);
				imagecopyresampled ( $newimage, $uploaded_image, 1, 1, 0, 0, $new_width-2, $newimage_height-2, $image_width, $image_height);
				imagepng ($newimage, "albums/album_".$album_id."/picture_".$picture_id.".png");
			}
			else
				$image_processed_ok = false;
			break;
		case 3:
			// PNG
			$uploaded_image = @imagecreatefrompng ($image_file);
			if ($uploaded_image)
			{
				$thumbnail = imagecreatetruecolor(150,$thumbnail_height);
				imagecopyresampled ( $thumbnail, $uploaded_image, 1, 1, 0, 0, 148, $thumbnail_height-2, $image_width, $image_height);
				imagepng ($thumbnail, "albums/album_".$album_id."/thumbnail_".$picture_id.".png");
				$newimage = imagecreatetruecolor($new_width,$newimage_height);
				imagecopyresampled ( $newimage, $uploaded_image, 1, 1, 0, 0, $new_width-2, $newimage_height-2, $image_width, $image_height);
				imagepng ($newimage, "albums/album_".$album_id."/picture_".$picture_id.".png");
			}
			else
				$image_processed_ok = false;
			break;
		default:
			$image_processed_ok = false;
	}
	unlink ("albums/tmp/".$_FILES['frmFile']['name']);

	if (!($image_processed_ok))
		$db->query ("DELETE FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($picture_id)."'");
	return $image_processed_ok;
}

function process_new_picture()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	// Copy uploaded image to the temporary directory
	if (move_uploaded_file($_FILES['frmFile']['tmp_name'], "albums/tmp/".$_FILES['frmFile']['name']))
	{
	    if (!$this->add_picture_to_album($this->clean_post['frmName'],$this->clean_post['frmDescription'],$this->clean_get['album_id'],"albums/tmp/".$_FILES['frmFile']['name']))
	    	return "Error processing image.";
	}
	else
		return "Error uploading file.";

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_upload_zip()
{
	// Output is not allowed here!!!!
	set_time_limit(600); // 10 minutes
	require_once ("config.php");
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	// Copy uploaded image to the temporary directory
	if (move_uploaded_file($_FILES['frmFile']['tmp_name'], "albums/tmp/".$_FILES['frmFile']['name']))
	{
		//$zip = zip_open("albums/tmp/".$_FILES['frmFile']['name']);
		$zip = zip_open(dirname($_SERVER['SCRIPT_FILENAME'])."/albums/tmp/".$_FILES['frmFile']['name']);

		if ($zip)
		{
	    	while ($zip_entry = zip_read($zip))
	    	{
		        // echo "Name:               " . zip_entry_name($zip_entry) . "\n";
		        // echo "Actual Filesize:    " . zip_entry_filesize($zip_entry) . "\n";
		        // echo "Compressed Size:    " . zip_entry_compressedsize($zip_entry) . "\n";
		        // echo "Compression Method: " . zip_entry_compressionmethod($zip_entry) . "\n";

		        if (zip_entry_open($zip, $zip_entry, "r"))
		        {
		            $buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
					$filename = "albums/tmp/".zip_entry_name($zip_entry);
		            $f = fopen($filename,"wb");
		            fwrite ($f,$buf);
		            fclose ($f);
		            zip_entry_close($zip_entry);
		            $this->add_picture_to_album("Picture","Picture",$this->clean_get['album_id'],$filename);
		        }
		    }
		    zip_close($zip);
		}
		else
			return "Failed to open the zip";

		unlink ("albums/tmp/".$_FILES['frmFile']['name']);
	}
	else
		return "Uploading zip failed.";


	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function process_delete_picture()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	global $db;
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($this->clean_get['picture_id'])."'");
	// Delete thumbnail and picture here
	unlink ("albums/album_".$this->clean_get['album_id']."/thumbnail_".$this->clean_get['picture_id'].".png");
	unlink ("albums/album_".$this->clean_get['album_id']."/picture_".$this->clean_get['picture_id'].".png");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_album_settings()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET thumbnail_columns='".$db->quote($this->clean_post['frmThumbnailColumns'])."' WHERE id='".$db->quote($this->clean_get['album_id'])."'");
	if ($this->clean_post['frmDefaultAlbum']=="on")
	{
		// this album has been made default album
		// delete default attribute from other albums in this box and mark this one default
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET default_album='0' WHERE box_id='".$db->quote($this->box_id)."'");
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET default_album='1' WHERE id='".$db->quote($this->clean_get['album_id'])."'");
	}
	else
	{
		// mark this album as not default
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET default_album='0' WHERE id='".$db->quote($this->clean_get['album_id'])."'");
	}
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_move_picture_down()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$album_id = $this->clean_get['album_id'];
	$picture_id = $this->clean_get['picture_id'];

	$current_picture = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($picture_id)."'");
    $max_picture_order = $db->get_var("SELECT MAX( display_order ) FROM `".XHP_TBL_PREFIX."gallery_pictures` WHERE album_id = '".$db->quote($album_id)."'");

	if ($current_picture->display_order<$max_picture_order)
	{
		// This is not the last picture
		$next_order = $current_picture->display_order+1;
		$next_picture = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE display_order='".$db->quote($next_order)."' AND album_id='".$db->quote($album_id)."'");
		// Switch orders
		$next_picture->display_order = $current_picture->display_order;
		$current_picture->display_order = $next_order;
		// Update database
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_pictures SET display_order='".$db->quote($current_picture->display_order)."' WHERE id='".$db->quote($current_picture->id)."'");
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_pictures SET display_order='".$db->quote($next_picture->display_order)."' WHERE id='".$db->quote($next_picture->id)."'");
	}

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_move_picture_up()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$album_id = $this->clean_get['album_id'];
	$picture_id = $this->clean_get['picture_id'];

	$current_picture = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE id='".$db->quote($picture_id)."'");

	if ($current_picture->display_order>0)
	{
		// This is not the first picture
		$previous_order = $current_picture->display_order-1;
		$previous_picture = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."gallery_pictures WHERE display_order='".$db->quote($previous_order)."' AND album_id='".$db->quote($album_id)."'");
		// Switch orders
		$previous_picture->display_order = $current_picture->display_order;
		$current_picture->display_order = $previous_order;
		// Update database
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_pictures SET display_order='".$db->quote($current_picture->display_order)."' WHERE id='".$db->quote($current_picture->id)."'");
		$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_pictures SET display_order='".$db->quote($previous_picture->display_order)."' WHERE id='".$db->quote($previous_picture->id)."'");
	}

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_make_album_thumbnail()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$album_id = $this->clean_get['album_id'];
	$picture_id = $this->clean_get['picture_id'];

	$db->query ("UPDATE ".XHP_TBL_PREFIX."gallery_albums SET thumbnail_id='".$db->quote($picture_id)."' WHERE id='".$db->quote($album_id)."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

} // class end
?>