<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * GuestBook - Quick hack of Links - twe
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_guestbook extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "delete_entry";
	$this->valid_actions[] = "display_new_entry";
	$this->valid_actions[] = "edit_entry";
	$this->valid_actions[] = "process_new_entry";
	$this->valid_actions[] = "process_edit_entry";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['id'] must be a valid guestbook entry id
	if (isset($_GET['id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."guest WHERE id='".$db->quote($_GET['id'])."'")>0)
			$this->clean_get['id'] = $_GET['id'];
	}

	// $_POST['frmComment'] doesn't have constraints
	if (isset($_POST['frmComment']))
		$this->clean_post['frmComment'] = strip_tags($_POST['frmComment']);

	// $_POST['frmName'] doesn't have constraints
	if (isset($_POST['frmName']))
		$this->clean_post['frmName'] = strip_tags($_POST['frmName']);
		
}


// Internal functions
function nls_and_urls($ret)
{
	$ret = ' ' . $ret;
	// matches an "xxxx://yyyy" URL at the start of a line, or after a space.
	// xxxx can only be alpha characters.
	// yyyy is anything up to the first space, newline, comma, double quote or <
	$ret = preg_replace("#([\t\r\n ])([a-z0-9]+?){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a rel="nofollow" href="\2://\3" target="_blank">\2://\3</a>', $ret);

	// matches a "www|ftp.xxxx.yyyy[/zzzz]" kinda lazy URL thing
	// Must contain at least 2 dots. xxxx contains either alphanum, or "-"
	// zzzz is optional.. will contain everything up to the first space, newline,
	// comma, double quote or <.
	$ret = preg_replace("#([\t\r\n ])(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i", '\1<a rel="nofollow" href="http://\2.\3" target="_blank">\2.\3</a>', $ret);

	// matches an email@domain type address at the start of a line, or after a space.
	// Note: Only the followed chars are valid; alphanums, "-", "_" and or ".".
	$ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);

	// Remove our padding..
	$ret = substr($ret, 1);

	return nl2br($ret);
}
// End module internal functions


function delete_instance()
{
	require_once ("config.php");
	global $db;
	$query = "DELETE FROM ".XHP_TBL_PREFIX."guest WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
}

function delete_module()
{
	require_once ("config.php");
	global $db;
	$query = "DROP TABLE ".XHP_TBL_PREFIX."guest";
	$db->query ($query);
}


function draw_module()
{
	require_once ("config.php");
	global $db;

	echo "<h3><img src=\"modules/guestbook/guestbook.gif\" alt=\"".$this->T_("GuestBook module")."\" />".$this->T_("GuestBook module")."</h3>";
	echo "<h4>["; $this->draw_edit_link($this->T_("New entry"),"guestbook","display_new_entry",null); echo "]</h4>\n";
	
	$this->test_error();

	$entries = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."guest WHERE box_id='".$db->quote($this->box_id)."' ORDER BY id DESC");
	if (is_array($entries))
	{
		foreach ($entries as $entry)
		{
			echo "<br />".stripslashes($entry->comment)."<br/><br/>\n";
			echo "<div class=\"frame\"><b>".$entry->name."</B></div>\n";
			echo "<div class=\"frame\"><i>".stripslashes($entry->date_posted)."</i></div>\n";
			echo "<h4>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
				echo "<h4>["; $this->draw_edit_link($this->T_("Edit"),"guestbook","edit_entry",null,array("id" => $entry->id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete"),"guestbook","delete_entry",null,array("id" => $entry->id)); echo "]</h4>\n";
			}
			echo "</h4>\n";
			echo "<hr/>\n";
		}
	}
}

function process_new_entry()
{
    require_once ("config.php");
    global $db;
	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."guest SET comment='".$db->quote($this->nls_and_urls($this->clean_post['frmComment']))."', name='".$db->quote($this->clean_post['frmName'])."', date_posted=now(), box_id='".$db->quote($this->box_id)."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function display_new_entry()
{
	require_once ("config.php");
	global $db;
	echo "<fieldset>\n";
	echo "<legend>".$this->T_("New entry")."</legend>\n";
	$this->draw_form_tag ("guestbook","process_new_entry","page=".$this->page_id,array(),true);
	echo "<table>\n";
	echo "<tr>\n";
	echo "<td>".$this->T_("Name").":</td>\n";
	echo "<td><input type=\"text\" name=\"frmName\" size=\"80\"/></td>\n";
	echo "</tr>\n";
	echo "<td colspan=\"2\">".$this->T_("Your comments").":</td></tr>\n";
	echo "<tr>\n";
	echo "<td colspan=\"2\">\n";
	echo "<textarea name=\"frmComment\" cols=\"60\" rows=\"10\"></textarea></td></tr>\n";
	echo "<tr><td colspan=\"2\">\n";
	echo "<button class=\"submit\" type=\"submit\">".$this->T_("Add")."</button>\n";
	echo "</td></tr>\n";
	echo "</table>\n";
	echo "</form>\n";
	echo "</fieldset>\n";
}


function edit_entry()
{
	echo "<fieldset>\n";
	echo "<legend>".$this->T_("Edit entry")."</legend>\n";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$entry = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."guest WHERE id='".$db->quote($this->clean_get['id'])."' LIMIT 1");
		$this->draw_form_tag("guestbook","process_edit_entry","page=".$this->page_id,array("id" => $this->clean_get['id']),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>Name:</td>\n";
		echo "<td><input type=\"text\" name=\"frmName\" size=\"40\" value=\"".strip_tags(stripslashes($entry->name))."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">Comments:</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea name=\"frmComment\" cols=\"50\" rows=\"10\">".strip_tags(stripslashes($entry->comment))."</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">Update</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function delete_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."guest WHERE id='".$db->quote($this->clean_get['id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_edit_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."guest SET comment='".$db->quote($this->nls_and_urls($this->clean_post['frmComment']))
		."',name='".$db->quote($this->clean_post['frmName'])
		."' WHERE id='".$db->quote($this->clean_get['id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

} // end of class
?>
