<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


require_once ("inc/xhp_module.inc.php");
class xhp_links extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "delete_entry";
	$this->valid_actions[] = "display_add_entry";
	$this->valid_actions[] = "edit_entry";
	$this->valid_actions[] = "process_edit_entry";
	$this->valid_actions[] = "process_new_entry";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation
	
	// $_GET['id'] must be a valid link id
	if (isset($_GET['id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."guest WHERE id='".$db->quote($_GET['id'])."'")>0)
			$this->clean_get['id'] = $_GET['id'];
	}

	// $_POST['frmTitle'] doesn't have constraints
	if (isset($_POST['frmTitle']))
		$this->clean_post['frmTitle'] = $_POST['frmTitle'];

	// $_POST['frmUrl'] doesn't have constraints
	// TODO: this should be validated as URL
	if (isset($_POST['frmUrl']))
		$this->clean_post['frmUrl'] = $_POST['frmUrl'];
		
	// $_POST['frmDescription'] doesn't have constraints
	if (isset($_POST['frmDescription']))
		$this->clean_post['frmDescription'] = $_POST['frmDescription'];
				
}
	
function delete_instance()
{
	require_once ("config.php");
	global $db;
	$query = "DELETE FROM ".XHP_TBL_PREFIX."links WHERE box_id='".$db->quote($this->box_id)."'";
	$db->query ($query);
}

function delete_module()
{
	require_once ("config.php");
	global $db;
	$query = "DROP TABLE ".XHP_TBL_PREFIX."links";
	$db->query ($query);
}


function draw_module()
{
	require_once ("config.php");
	global $db;

	echo "<h3>".$this->T_("Links module")."</h3>";
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		echo "<h4>["; $this->draw_edit_link($this->T_("Add new link"),"links","display_add_entry",null); echo "]</h4>\n";
	}

	$this->test_error();

	$links = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."links WHERE box_id='".$db->quote($this->box_id)."' ORDER BY title ASC");
	if (is_array($links))
	{
		foreach ($links as $link)
		{
			echo "<br /><h3>".stripslashes($link->title)."</h3>\n";
			echo "<div class=\"frame\"><a href=\"".$link->url."\">".$link->url."</a></div>\n";
			echo "<div class=\"frame\">".stripslashes($link->description)."</div>\n";
			if ($this->access_level >= XHP_ACCESS_EDIT)
			{
   				echo "<h4>["; $this->draw_edit_link($this->T_("Edit"),"links","edit_entry",null,array("id" => $link->id)); echo "]\n";
				echo "["; $this->draw_action_link($this->T_("Delete"),"links","delete_entry",null,array("id" => $link->id)); echo "]</h4>\n";
			}
			echo "<hr/>\n";
		}
	}
}

function edit_entry()
{
	echo "<fieldset>\n";
	echo "<legend>".$this->T_("Links - edit entry")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$link = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."links WHERE id='".$db->quote($this->clean_get['id'])."' LIMIT 1");
		$this->draw_form_tag("links","process_edit_entry","page=".$this->page_id,array("id" => $this->clean_get['id']),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Title").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmTitle\" size=\"80\" value=\"".strip_tags(stripslashes($link->title))."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("URL").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmUrl\" size=\"80\" value=\"".$link->url."\"/></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea name=\"frmDescription\" cols=\"60\" rows=\"10\">".strip_tags(stripslashes($link->description))."</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Update")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}

function display_add_entry()
{
	echo "<fieldset>\n";
	echo "<legend>".$this->T_("Add new link")."</legend>";
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_EDIT)
	{
		$this->draw_form_tag ("links","process_new_entry","page=".$this->page_id,array(),true);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Title").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmTitle\" size=\"80\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("URL").":</td>\n";
		echo "<td><input type=\"text\" name=\"frmUrl\" size=\"80\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">".$this->T_("Description").":</td></tr>\n";
		echo "<tr>\n";
		echo "<td colspan=\"2\">\n";
		echo "<textarea name=\"frmDescription\" cols=\"60\" rows=\"10\"></textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\">\n";
		echo "<button class=\"submit\" type=\"submit\">".$this->T_("Add")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
	echo "</fieldset>\n";
}


function process_new_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."links SET title='".$db->quote($this->clean_post['frmTitle'])
		."',url='".$db->quote($this->clean_post['frmUrl'])."', description='".nl2br($db->quote($this->clean_post['frmDescription']))
		."', box_id='".$db->quote($this->box_id)."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function delete_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("DELETE FROM ".XHP_TBL_PREFIX."links WHERE id='".$db->quote($this->clean_get['id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_edit_entry()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_EDIT)
		return $this->T_("Not authorized");
	$db->query ("UPDATE ".XHP_TBL_PREFIX."links SET title='".$db->quote($this->clean_post['frmTitle'])
		."',url='".$db->quote($this->clean_post['frmUrl'])."', description='".nl2br($db->quote($this->clean_post['frmDescription']))
		."' WHERE id='".$db->quote($this->clean_get['id'])."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

} // class end
?>
