<?php
/*
 *
 *  XHP - eXpandable Home Page [xhp.targetit.ro]
 *  Copyright (C) 2003-2005
 *  Laurentiu "Lars" Matei <laurentiu.matei@targetit.ro>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

require_once ("inc/xhp_module.inc.php");
class xhp_users extends xhp_module
{

function register_valid_actions()
{
	$this->valid_actions[] = "login";
	$this->valid_actions[] = "logout";
	$this->valid_actions[] = "process_upload_module";
	$this->valid_actions[] = "process_theme";
	$this->valid_actions[] = "process_upload_theme";
	$this->valid_actions[] = "process_edit_pages";
	$this->valid_actions[] = "process_add_page";
	$this->valid_actions[] = "process_general_config";
	$this->valid_actions[] = "process_user_profile";
	$this->valid_actions[] = "process_change_password";
	$this->valid_actions[] = "display_module_manager";
	$this->valid_actions[] = "display_theme_manager";
	$this->valid_actions[] = "display_pages_manager";
	$this->valid_actions[] = "display_site_settings";
	$this->valid_actions[] = "display_user_profile";
	$this->valid_actions[] = "display_change_password";
	$this->valid_actions[] = "process_delete_module";
	$this->valid_actions[] = "process_delete_theme";
	$this->valid_actions[] = "move_page_up";
	$this->valid_actions[] = "move_page_down";
	$this->valid_actions[] = "process_delete_page";
}

function process_input()
{
	require_once ("config.php");
	global $db;
	xhp_module::process_input();
	// module specific input validation

	require_once ("inc/engine_security.inc.php");
	global $clean_post, $clean_get, $clean_cookie;
	$this->clean_get['page_id'] = $clean_get['page_id'];
	
	// $_GET['id'] must be a valid module id
	if (isset($_GET['id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."modules WHERE module_id='".$db->quote($_GET['id'])."'")>0)
			$this->clean_get['id'] = $_GET['id'];
	}
	
	// $_GET['name'] must be a valid theme name;
	if ((strstr($_GET['name'],".."))===FALSE)
	{
		$dir = "themes/".$_GET['name'];
		if (is_dir($dir))
			$clean_get['name'] = $_GET['name'];
	}
	
	// $_GET['user_id'] must be a valid user id
	if (isset($_GET['user_id']))
	{
		if ($db->get_var ("SELECT COUNT(*) FROM ".XHP_TBL_PREFIX."users WHERE id='".$db->quote($_GET['user_id'])."'")>0)
			$this->clean_get['user_id'] = $_GET['user_id'];
	}
	
	// $_POST['frmUsername'] doesn't have constraints
	if (isset($_POST['frmUsername']))
		$this->clean_post['frmUsername'] = $_POST['frmUsername'];

	// $_POST['frmPassword'] doesn't have constraints
	if (isset($_POST['frmPassword']))
		$this->clean_post['frmPassword'] = $_POST['frmPassword'];

	// $_POST['frmPageTitle'] must not contain HTML
	if (isset($_POST['frmPageTitle']))
		$this->clean_post['frmPageTitle'] = strip_tags($_POST['frmPageTitle']);

	// $_POST['frmPageUrl'] doesn't have constraints
	// TODO: this should be validated as URL
	if (isset($_POST['frmPageUrl']))
		$this->clean_post['frmPageUrl'] = $_POST['frmPageUrl'];
		
	// $_POST['frmPageDescription'] must not contain HTML
	if (isset($_POST['frmPageDescription']))
		$this->clean_post['frmPageDescription'] = strip_tags($_POST['frmPageDescription']);

	// $_POST['frmLanguage'] doesn't have constraints
	// TODO: this should be a valid language
	if (isset($_POST['frmLanguage']))
		$this->clean_post['frmLanguage'] = $_POST['frmLanguage'];

	// $_POST['frmNewPassword'] doesn't have constraints
	if (isset($_POST['frmNewPassword']))
		$this->clean_post['frmNewPassword'] = $_POST['frmNewPassword'];

	// $_POST['frmTheme'] doesn't have constraints
	// TODO: this should be a valid theme
	if (isset($_POST['frmTheme']))
		$this->clean_post['frmTheme'] = $_POST['frmTheme'];

	// $_POST['frmPageParentId'] must be a number
	// TODO: this should be a valid page id
	if (isset($_POST['frmPageParentId']))
		if (is_numeric($_POST['frmPageParentId']))
				$this->clean_post['frmPageParentId'] = $_POST['frmPageParentId'];
														
	// $_POST['frmPageName'] must not contain HTML
	if (isset($_POST['frmPageName']))
		$this->clean_post['frmPageName'] = strip_tags($_POST['frmPageName']);

	// $_POST['frmPageTheme'] doesn't have constraints
	// TODO: this should be a valid theme
	if (isset($_POST['frmPageTheme']))
		$this->clean_post['frmPageTheme'] = $_POST['frmPageTheme'];

	// $_POST['frmNumberOfPages'] must be a number
	if (isset($_POST['frmNumberOfPages']))
		if (is_numeric($_POST['frmNumberOfPages']))
				$this->clean_post['frmNumberOfPages'] = $_POST['frmNumberOfPages'];
				
	// $_POST['frmNewPassword'] doesn't have constraints
	if (isset($_POST['frmNewPassword']))
		$this->clean_post['frmNewPassword'] = $_POST['frmNewPassword'];

	// TODO: This stuff should be rewritten (too complicated)
	$nopages = $this->clean_post['frmNumberOfPages'];
	for ($i = 0; $i < $nopages; $i++)
	{
		$index = "frmPageId".$i;
		//echo $index."<br>";
		if (isset($_POST[$index]))
			if (is_numeric($_POST[$index]))
			{
				$this->clean_post[$index] = $_POST[$index];
				$page_id = $this->clean_post[$index];
				$page_active = "frmPage".$page_id."Active";
				$this->clean_post[$page_active] = $_POST[$page_active];

				$page_title = "frmPage".$page_id."Title";
				$page_theme = "frmPage".$page_id."Theme";
				$page_parentid = "frmPage".$page_id."ParentId";
				
				$this->clean_post[$page_title] = $_POST[$page_title];
				$this->clean_post[$page_theme] = $_POST[$page_theme];
				$this->clean_post[$page_parentid] = $_POST[$page_parentid];
			}
	}
	
	// $_POST['frmFirstName'] doesn't have constraints
	if (isset($_POST['frmFirstName']))
		$this->clean_post['frmFirstName'] = $_POST['frmFirstName'];

	// $_POST['frmLastName'] doesn't have constraints
	if (isset($_POST['frmLastName']))
		$this->clean_post['frmLastName'] = $_POST['frmLastName'];
		
}

function draw_module()
{
    require_once ("config.php");
    global $db;
	echo "<h3><img align=\"absmiddle\" src=\"modules/users/admin.gif\" alt=\"".$this->T_("Admin")."\" />".$this->T_("Admin")."</h3>";
	$this->test_error();

	//require_once("inc/authentication.inc.php");
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		// Current user is admin
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/module_manager.gif\" alt=\"".$this->T_("Module manager")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_module_manager\">".$this->T_("Module manager")."</a></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/theme_manager.gif\" alt=\"".$this->T_("Theme manager")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_theme_manager\">".$this->T_("Theme manager")."</a></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/pages_manager.gif\" alt=\"".$this->T_("Pages manager")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_pages_manager\">".$this->T_("Pages manager")."</a></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/file_manager.gif\" alt=\"".$this->T_("File manager")."\" />";
		echo "<a href=\"inc/htmlarea/plugins/FileManager/standalonemanager.php\" target=\"imgManager\" onclick=\"window.open(this.href,'editdialog','toolbar=no,menubar=no,personalbar=no,width=600,height=500,scrollbars=yes,resizable=yes,modal=yes,dependable=yes'); return false;\">".$this->T_("File manager")."</a>";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/site_settings.gif\" alt=\"".$this->T_("Site settings")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_site_settings\">".$this->T_("Site settings")."</a></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/user_profile.gif\" alt=\"".$this->T_("User profile")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_user_profile\">".$this->T_("User profile")."</a></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td><img align=\"absmiddle\" src=\"modules/users/change_password.gif\" alt=\"".$this->T_("Change password")."\" /><a href=\"index.php?page=".$this->page_id."&amp;box_id=".$this->box_id."&amp;action=display_change_password\">".$this->T_("Change password")."</a></td>\n";
		echo "</tr>\n";
		echo "</table>\n";
	}
	else
	{
		// User not logged in
		// Display login form
		$this->draw_form_tag("users","login",null);
		echo "<table>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Username")."</td>\n";
		echo "<td><input type=\"text\" name=\"frmUsername\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td>".$this->T_("Password")."</td>\n";
		echo "<td><input type=\"password\" name=\"frmPassword\" /></td>\n";
		echo "</tr>\n";
		echo "</tr><td colspan=\"2\">\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Login")."</button>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
 	}
}


function login()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	$res = $db->get_var ("SELECT id FROM ".XHP_TBL_PREFIX."users WHERE username='".$db->quote($this->clean_post['frmUsername'])
		."' and password='".$db->quote($this->clean_post['frmPassword'])."'");
	if ($res == null)
	{
		return "Authentication failed.";
	}
	else
	{
		$db->query ("UPDATE ".XHP_TBL_PREFIX."users SET session_id='".$db->quote(session_id())."' where id='".$db->quote($res)."'");
	}
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function logout()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
    $db->query ("UPDATE ".XHP_TBL_PREFIX."users SET session_id='' where session_id='".$db->quote(session_id())."'");
	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function process_general_config()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($this->clean_post['frmPageTitle'])."' WHERE variable='PAGE_TITLE'");
		// Make sure the URL ends with "/"
		$pageurl = "";
		if (strrpos($this->clean_post['frmPageUrl'],"/")!=strlen($this->clean_post['frmPageUrl'])-1)
			$pageurl = $this->clean_post['frmPageUrl']."/";
		else
			$pageurl = $this->clean_post['frmPageUrl'];
		$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($pageurl)."' WHERE variable='PAGE_URL'");
		$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($this->clean_post['frmPageDescription'])."' WHERE variable='PAGE_DESCRIPTION'");
		$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($this->clean_post['frmLanguage'])."' WHERE variable='LANGUAGE'");
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}

	// Action functions must return an error code that can be used
	// by display functions
}


function process_change_password()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$db->query ("UPDATE ".XHP_TBL_PREFIX."users SET password='".$db->quote($this->clean_post['frmNewPassword'])."'");
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
	
	// Action functions must return an error code that can be used
	// by display functions
}

function process_theme()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$db->query ("UPDATE ".XHP_TBL_PREFIX."config SET value='".$db->quote($this->clean_post['frmTheme'])."' WHERE variable='THEME'");
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
	
	// Action functions must return an error code that can be used
	// by display functions
}



function process_add_page()
{
    // Output is not allowed here!!!!
    require_once ("config.php");
    global $db;

	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
	    // menu order is the biggest order in its level + 1
	    $menu_order = $db->get_var("SELECT MAX( menu_order ) FROM `".XHP_TBL_PREFIX."pages` WHERE parent_id = '".$db->quote($this->clean_post['frmPageParentId'])."'");
	    if ($menu_order == null)
        	$menu_order = 0;
    	else
	        $menu_order++;

    	$db->query ("INSERT INTO ".XHP_TBL_PREFIX."pages SET title='".$db->quote($this->clean_post['frmPageName'])
	        ."', active='0', theme='".$db->quote($this->clean_post['frmPageTheme'])
        	."', parent_id='".$db->quote($this->clean_post['frmPageParentId'])
        	."', menu_order='".$db->quote($menu_order)."'");
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}

    // Action functions must return an error code that can be used
    // by display functions
}

function process_edit_pages()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$nopages = $this->clean_post['frmNumberOfPages'];
		//echo $nopages;

		for ($i = 0; $i < $nopages; $i++)
		{
			$index = "frmPageId".$i;
			//echo $index."<br>";
			$page_id = $this->clean_post[$index];
	
			$page_active = "frmPage".$page_id."Active";
			if ($this->clean_post[$page_active] == "on")
				$active = 1;
			else
				$active = 0;
			$page_title = "frmPage".$page_id."Title";
			$page_theme = "frmPage".$page_id."Theme";
			$page_parentid = "frmPage".$page_id."ParentId";
	
			$query = "UPDATE ".XHP_TBL_PREFIX."pages SET title='".$db->quote($this->clean_post[$page_title])
				."', active='".$db->quote($active)."', theme='".$db->quote($this->clean_post[$page_theme])
				."', parent_id='".$db->quote($this->clean_post[$page_parentid])
				."' WHERE page_id='".$db->quote($page_id)."'";
			$db->query($query);
		}
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}

	// Action functions must return an error code that can be used
	// by display functions
}

function update_page_orders()
{
	require_once ("config.php");
	global $db;
	
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$parent_id = -2;
		$order = 0;
		$pages = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."pages ORDER BY parent_id ASC, menu_order ASC");
		if (is_array($pages))
		{
			foreach ($pages as $page)
			{
				if ($page->parent_id != $parent_id)
				{
					$parent_id = $page->parent_id;
					$order = 0;
				}
				$order++;
				$db->query ("UPDATE ".XHP_TBL_PREFIX."pages SET menu_order='".$db->quote($order)."' WHERE page_id='".$db->quote($page->page_id)."'");
			}
		}
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
}

function move_page_down()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$page_id = $this->clean_get['page_id'];
		$current_page = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($page_id)."'");
	    $max_menu_order = $db->get_var("SELECT MAX( menu_order ) FROM `".XHP_TBL_PREFIX."pages` WHERE parent_id = '".$db->quote($current_page->parent_id)."'");
		if ($current_page->menu_order<$max_menu_order)
		{
			// This is not the last page
			$next_order = $current_page->menu_order+1;
			$next_page = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE menu_order='".$db->quote($next_order)."' AND parent_id='".$db->quote($current_page->parent_id)."'");
			if ($next_page != null)
			{
				// next page exists
				// Switch orders
				$next_page->menu_order = $current_page->menu_order;
				$current_page->menu_order = $next_order;
				// Update database
				$db->query ("UPDATE ".XHP_TBL_PREFIX."pages SET menu_order='".$db->quote($current_page->menu_order)."' WHERE page_id='".$db->quote($current_page->page_id)."'");
				$db->query ("UPDATE ".XHP_TBL_PREFIX."pages SET menu_order='".$db->quote($next_page->menu_order)."' WHERE page_id='".$db->quote($next_page->page_id)."'");
			}
		}
		$this->update_page_orders();

		// Action functions must return an error code that can be used
		// by display functions
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
}

function move_page_up()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$page_id = $this->clean_get['page_id'];
		$current_page = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($page_id)."' LIMIT 1");

		if ($current_page->menu_order>1)
		{
			// This is not the first page
			$previous_order = $current_page->menu_order-1;
			$previous_page = $db->get_row("SELECT * FROM ".XHP_TBL_PREFIX."pages WHERE menu_order='".$db->quote($previous_order)."' AND parent_id='".$db->quote($current_page->parent_id)."'");
			// Switch orders
			if ($previous_page != null)
			{
				// previous page exists
				$previous_page->menu_order = $current_page->menu_order;
				$current_page->menu_order = $previous_order;
				// Update database
				$db->query ("UPDATE ".XHP_TBL_PREFIX."pages SET menu_order='".$db->quote($current_page->menu_order)."' WHERE page_id='".$db->quote($current_page->page_id)."'");
				$db->query ("UPDATE ".XHP_TBL_PREFIX."pages SET menu_order='".$db->quote($previous_page->menu_order)."' WHERE page_id='".$db->quote($previous_page->page_id)."'");
			}
		}

    	$this->update_page_orders();
		// Action functions must return an error code that can be used
		// by display functions
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
}

function process_delete_page()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;

	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$page_id = $this->clean_get['page_id'];
	
		// delete modules and module content from page
		$boxes = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."boxes WHERE page_id='".$db->quote($page_id)."'");
		if (is_array($boxes))
		{
			foreach ($boxes as $box)
			{
				// initialize module object
				require_once ("modules/".$box->module_id."/".$box->module_id.".xhpm.php");
				$classname = "xhp_".$box->module_id;
				$objmodule = new $classname($box->module_id,$box->id,$box->page_id,$this->access_level);
				//$objmodule->box_id = $box->id;
				//$objmodule->page_id = $box->page_id;
				$objmodule->delete_instance();
			}
		}
	
		$db->query ("DELETE FROM ".XHP_TBL_PREFIX."pages WHERE page_id='".$db->quote($page_id)."'");
	    $this->update_page_orders();
		// Action functions must return an error code that can be used
		// by display functions
		return 0;
	}
	else
	{
		return $this->T_("Not authorized");
	}
}


function display_module_manager()
{
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		// User logged in
		echo "<h3><img align=\"absmiddle\" src=\"modules/users/module_manager.gif\" alt=\"".$this->T_("Module manager")."\" />".$this->T_("Module manager")."</h3>\n";
		$this->test_error();
		global $db;
		$modules = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."modules");
		echo "<table width=\"100%\">\n";
		foreach ($modules as $module)
		{
			echo "<tr>\n";
			echo "<td>".$module->name."</td>\n";
			echo "<td>";
			$this->draw_action_link($this->T_("Delete"),"users","process_delete_module",null,array("id" => $module->module_id));
			echo "</td>\n";
			echo "</tr>\n";
		}
		echo "</table>\n";

		// Upload module
		echo "<br /><h3>".$this->T_("Upload module")."</h3>\n";
		$this->draw_form_tag("users","process_upload_module",null);
		echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"100000000\" />\n";
		echo "<input type=\"file\" name=\"frmFile\" size=\"40\" /><br />\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Upload module")."</button>\n";
		echo "</form>\n";
	}
}

function process_upload_module()
{
	// Output is not allowed here!!!!
	set_time_limit(600); // 10 minutes
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_ADMIN)
		return $this->T_("Not authorized");
	
	// Copy uploaded module zip to the temporary directory
	if (move_uploaded_file($_FILES['frmFile']['tmp_name'], "tmp/".$_FILES['frmFile']['name']))
	{
		// build tmp path
		$tmp_path = str_replace("action.php","tmp/",$_SERVER['SCRIPT_FILENAME']);
		$zip = zip_open($tmp_path.$_FILES['frmFile']['name']);
		if ($zip)
		{
	    	while ($zip_entry = zip_read($zip))
	    	{
		        // echo "Name:               " . zip_entry_name($zip_entry) . "\n";
		        // echo "Actual Filesize:    " . zip_entry_filesize($zip_entry) . "\n";
		        // echo "Compressed Size:    " . zip_entry_compressedsize($zip_entry) . "\n";
		        // echo "Compression Method: " . zip_entry_compressionmethod($zip_entry) . "\n";

		        if (zip_entry_open($zip, $zip_entry, "r"))
		        {
		            $buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
					$filename = "tmp/".zip_entry_name($zip_entry);
		            $f = fopen($filename,"wb");
		            fwrite ($f,$buf);
		            fclose ($f);
		            zip_entry_close($zip_entry);
		        }
		    }
		    zip_close($zip);
		    // Decompress finished

		    // Try to read module definition file
		    global $depth, $module_definition, $current_tag;
            $depth = array();
            $module_definition = array();
            $module_definition["files"] = array();
            $module_definition["language_files"] = array();
            $module_definition["template_objects"] = array();
			$xml_parser = xml_parser_create();
			xml_set_element_handler($xml_parser, array($this,"startElement"), array($this,"endElement"));
            xml_set_character_data_handler($xml_parser, array($this,"characterData"));
			if (!($fp = fopen("tmp/xhp_module.xml", "r")))
				return ("Failed opening module definition file.");
			while ($data = fread($fp, 4096))
			{
				if (!xml_parse($xml_parser, $data, feof($fp)))
				{
					return(sprintf("XML error: %s at line %d",
						xml_error_string(xml_get_error_code($xml_parser)),
						xml_get_current_line_number($xml_parser)));
				}
			}
			fclose ($fp);
			xml_parser_free($xml_parser);

			// Run the SQL file
			if (isset($module_definition['SQL_FILE']))
			{
				if (!($fp = fopen ("tmp/".$module_definition['SQL_FILE'],"r")))
					return ("Failed opening module SQL file.");
				$sqlfile = "";
				while ($data = fread($fp,4096))
					$sqlfile .= $data;
				fclose ($fp);
				$sqlfile = str_replace("XHP_TBL_PREFIX",XHP_TBL_PREFIX,$sqlfile);

				// process SQL file
				require_once ("inc/sqlfile.inc.php"); // PHPMyAdmin library
				$queries = array();
				if (!PMA_splitSqlFile($queries,$sqlfile))
					return "Failed importing SQL file";
				foreach ($queries as $query)
				{
					if (!$db->query ($query))
						return mysql_error();
				}
			    // end process SQL file
			}

			// Copy the module files
			if (isset($module_definition['MODULE_ID']))
			{
				@mkdir("modules/".$module_definition['MODULE_ID']);
	            foreach ($module_definition["files"] as $file)
	            {
	            	@copy ("tmp/".$file,"modules/".$module_definition['MODULE_ID']."/".$file);
	            }

    	        // Register the module in the database
	            $query = "INSERT INTO ".XHP_TBL_PREFIX."modules SET name='".$db->quote($module_definition['NAME'])."', module_id='".$db->quote($module_definition['MODULE_ID'])."'";
	            if (!$db->query ($query))
	            	return $db->xhp_mysql_error();
	        }

            // Copy language files if any
            foreach ($module_definition["language_files"] as $file)
            {
            	@copy ("tmp/".$file,"languages/".$file);
            }
            // End copy language files

            // Process template objects
            foreach ($module_definition["template_objects"] as $arr_template_object)
            {
				$placeholder = $arr_template_object["placeholder"];
				$handler = fopen ("tmp/".$arr_template_object["php_code_file"],"rb");
				$php_code = fread($handler,filesize("tmp/".$arr_template_object["php_code_file"]));
				fclose ($handler);
				$db->query ("INSERT INTO ".XHP_TBL_PREFIX."template_objects SET placeholder='".$db->quote($placeholder)."', php_code='".$db->quote($php_code)."'");
            }
            // End process template objects
		}
		else
			return "Failed to open the zip";

		@unlink ("tmp/".$_FILES['frmFile']['name']);
	}
	else
		return "Uploading zip failed.";


	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function startElement($parser, $name, $attrs)
{
    global $depth, $module_definition, $current_tag, $template_object_index;
    $current_tag = $name;
    if ($current_tag == "TEMPLATE_OBJECT")
    {
    	$module_definition["template_objects"][] = array();
    	$template_object_index = count($module_definition["template_objects"])-1;
    }
    $depth[$parser]++;
}

function endElement($parser, $name)
{
    global $depth;
    $depth[$parser]--;
}

function characterData($parser, $data)
{
	global $current_tag, $module_definition, $template_object_index;
	if (trim($data)!="")
	{
		if ($current_tag == "FILE")
			$module_definition["files"][] = $data;
		else if ($current_tag == "LANGUAGE_FILE")
			$module_definition["language_files"][] = $data;
		else if ($current_tag == "PLACEHOLDER")
			$module_definition["template_objects"][$template_object_index]["placeholder"] = $data;
		else if ($current_tag == "PHP_CODE_FILE")
			$module_definition["template_objects"][$template_object_index]["php_code_file"] = $data;
		else
			$module_definition[$current_tag] = $data;
	}
}

function process_delete_module()
{
	// Output is not allowed here!!!!
	set_time_limit(600); // 10 minutes
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_ADMIN)
		return $this->T_("Not authorized");

	// Call module's cleanup function
	$module_id = $this->clean_get['id'];
	require_once ("modules/".$module_id."/".$module_id.".xhpm.php");
	$classname = "xhp_".$module_id;
	$objmodule = new $classname($module_id,$this->clean_get['box_id'],$this->clean_get['page_id'],$this->access_level);
	$objmodule->delete_module();

		
	// Delete the boxes using this module
    $query = "DELETE FROM ".XHP_TBL_PREFIX."boxes WHERE module_id='".$db->quote($this->clean_get['id'])."'";
    $db->query($query);

	// Unregister module from database
	$query = "DELETE FROM ".XHP_TBL_PREFIX."modules WHERE module_id='".$db->quote($this->clean_get['id'])."'";
	$db->query($query);


	// TODO: Delete the module directory


	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function display_theme_manager()
{
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		// User logged in
		echo "<h3><img align=\"absmiddle\" src=\"modules/users/theme_manager.gif\" alt=\"".$this->T_("Template manager")."\" />".$this->T_("Template manager")."</h3>\n";
		$this->test_error();
		echo "<h3>".$this->T_("Choose template")."</h3>\n";
		echo "<br />";
        $this->draw_form_tag("users","process_theme",null);
		echo "<select name=\"frmTheme\">\n";
		$dir = "themes";
		$themes = array();
		if (is_dir($dir))
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
					if (($file!=".")&&($file!="..")&&($file!="CVS")&&(strtolower($file)!="readme"))
					{
						echo "<option value=\"".$file."\" ";
						if ($file==XHP_C_THEME)
							echo "selected";
						echo ">".$file."</option>\n";
						$themes[] = $file;
					}
				closedir($dh);
			}
		}
		echo "</select>\n";
		echo "<input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\" />\n";
		echo "</form><br />\n";

        // Installed themes
        echo "<h3>".$this->T_("Installed templates")."</h3>\n";
        echo "<table width=\"100%\">\n";
        foreach ($themes as $theme)
        {
        	echo "<tr>\n";
        	echo "<td>".$theme."</td>\n";
			echo "<td>";
			$this->draw_action_link($this->T_("Delete"),"users","process_delete_theme",null,array("name" => $theme));
			echo "</td>\n";
        	echo "</tr>\n";
        }
        echo "</table>\n";
        // End install themes

		// Upload module
		echo "<h3>".$this->T_("Upload template")."</h3>\n";
		$this->draw_form_tag("users","process_upload_theme",null);
		echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"100000000\" />\n";
		echo "<input type=\"file\" name=\"frmFile\" size=\"40\" /><br />\n";
		echo "<button type=\"submit\" class=\"submit\">".$this->T_("Upload template")."</button>\n";
		echo "</form>\n";
	}
}

function process_upload_theme()
{
	// Output is not allowed here!!!!
	set_time_limit(600); // 10 minutes
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_ADMIN)
		return $this->T_("Not authorized");
	// Copy uploaded theme zip to the temporary directory
	if (move_uploaded_file($_FILES['frmFile']['tmp_name'], "tmp/".$_FILES['frmFile']['name']))
	{
		$tmp_path = str_replace("action.php","tmp/",$_SERVER['SCRIPT_FILENAME']);
		$zip = zip_open($tmp_path.$_FILES['frmFile']['name']);
		if ($zip)
		{
	    	while ($zip_entry = zip_read($zip))
	    	{
		        // echo "Name:               " . zip_entry_name($zip_entry) . "\n";
		        // echo "Actual Filesize:    " . zip_entry_filesize($zip_entry) . "\n";
		        // echo "Compressed Size:    " . zip_entry_compressedsize($zip_entry) . "\n";
		        // echo "Compression Method: " . zip_entry_compressionmethod($zip_entry) . "\n";

		        if (zip_entry_open($zip, $zip_entry, "r"))
		        {
		            $buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
					$filename = "tmp/".zip_entry_name($zip_entry);
		            $f = fopen($filename,"wb");
		            fwrite ($f,$buf);
		            fclose ($f);
		            zip_entry_close($zip_entry);
		        }
		    }
		    zip_close($zip);
		    // Decompress finished

		    // Try to read theme definition file
		    global $depth, $module_definition, $current_tag;
            $depth = array();
            $module_definition = array();
            $module_definition["files"] = array();
			$xml_parser = xml_parser_create();
			xml_set_element_handler($xml_parser, array($this,"startElement"), array($this,"endElement"));
            xml_set_character_data_handler($xml_parser, array($this,"characterData"));
			if (!($fp = fopen("tmp/xhp_theme.xml", "r")))
				return ("Failed opening theme definition file.");
			while ($data = fread($fp, 4096))
			{
				if (!xml_parse($xml_parser, $data, feof($fp)))
				{
					return(sprintf("XML error: %s at line %d",
						xml_error_string(xml_get_error_code($xml_parser)),
						xml_get_current_line_number($xml_parser)));
				}
			}
			fclose ($fp);
			xml_parser_free($xml_parser);

			// Copy the theme files
			@mkdir("themes/".$module_definition['NAME']);
            foreach ($module_definition["files"] as $file)
            {
            	@copy ("tmp/".$file,"themes/".$module_definition['NAME']."/".$file);
            }

            // Process the 2 html files (theme.html and theme_edit.html)
            if (file_exists("themes/".$module_definition['NAME']."/theme.html"))
	            $this->process_template_objects("themes/".$module_definition['NAME']."/theme.html");
	        else
	        	return "theme.html not found";
	        if (file_exists("themes/".$module_definition['NAME']."/theme_edit.html"))
	            $this->process_template_objects("themes/".$module_definition['NAME']."/theme_edit.html");
	        else
	        	return "theme_edit.html not found";
		}
		else
			return "Failed to open the zip";

		@unlink ("tmp/".$_FILES['frmFile']['name']);
	}
	else
		return "Uploading zip failed.";

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}

function process_template_objects($html_file)
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level < XHP_ACCESS_ADMIN)
		return $this->T_("Not authorized");

	$handle = fopen ($html_file, "rb");
	$html_content = fread ($handle, filesize ($html_file));
	fclose ($handle);

    // Process standard template objects
    $template_objects = $db->get_results ("SELECT * FROM ".XHP_TBL_PREFIX."template_objects");
    if (is_array($template_objects))
    {
    	foreach ($template_objects as $template_object)
    	{
    		$html_content = str_replace("[".$template_object->placeholder."]",$template_object->php_code,$html_content);
    	}
    }
    // Process boxes
    $html_content = preg_replace_callback("/\[BOX:(.*)\]/","process_boxes",$html_content);
    // Process relative links
	// I hate this global thing but I have no idea for now
	global $theme_path;
	$theme_path = dirname($html_file);
    $html_content = preg_replace_callback("/href=\"(.*)\"/i","process_links",$html_content);
    $html_content = preg_replace_callback("/src=\"(.*)\"/i","process_links",$html_content);
    $html_content = preg_replace_callback("/url\((.*)\)/i","process_links",$html_content);

	$php_file = $html_file;
	$dot_index = strrpos($php_file,".");
	$php_file = substr($php_file,0,$dot_index+1);
	$php_file .= "php";
    $handle = fopen ($php_file,"wb");
    fwrite ($handle,$html_content);
    fclose ($handle);

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function process_delete_theme()
{
	// Output is not allowed here!!!!
	set_time_limit(600); // 10 minutes
	require_once ("config.php");
	if ($this->access_level < XHP_ACCESS_ADMIN)
		return $this->T_("Not authorized");

	// Delete the theme directory
	$dir = "themes/".$this->clean_get['name'];
	if (is_dir($dir))
	{
		if ($dh = opendir($dir))
		{
			while (($file = readdir($dh)) !== false)
				if (($file!=".")&&($file!=".."))
				{
					@unlink($dir."/".$file);
				}
			closedir($dh);
		}
		@rmdir($dir);
	}
	else
		return "Theme does not exist";

	// Action functions must return an error code that can be used
	// by display functions
	return 0;
}


function display_pages_manager()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
        // Edit pages
        echo "<h3><img align=\"absmiddle\" src=\"modules/users/pages_manager.gif\" alt=\"".$this->T_("Pages manager")."\" />".$this->T_("Pages manager")."</h3>\n";
        $pages = $db->get_results("SELECT * FROM ".XHP_TBL_PREFIX."pages ORDER BY parent_id ASC, menu_order ASC");
		$this->draw_form_tag("users","process_edit_pages",null);
        echo "<table>\n";
        echo "<tr><th>".$this->T_("Active")."</th><th>".$this->T_("Page name")."</th><th>".$this->T_("Page template")
               ."</th><th>".$this->T_("Parent page in the menu")
               ."</th><th>".$this->T_("Actions")."</th></tr>\n";

		// get theme list
		$dir = "themes";
		$themes = array();
		$themes[] = "site_scheme";
		if (is_dir($dir))
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
					if (($file!=".")&&($file!="..")&&($file!="zfeeder")&&($file!="CVS")&&($file!="README"))
					{
						$themes[] = $file;
					}
				closedir($dh);
			}
		}
		// end get theme list

        $i = 0;
        foreach ($pages as $page)
        {
            echo "<tr>\n";
            // Active
            echo "<td>";
            echo "<input type=\"hidden\" name=\"frmPageId".$i."\" value=\"".$page->page_id."\" />\n";
            echo "<input type=\"checkbox\" name=\"frmPage".$page->page_id."Active\" ";
            if ($page->active==1)
                echo "checked";
            echo "></input></td>\n";
            // Page title
            echo "<td><input type=\"text\" name=\"frmPage".$page->page_id."Title\" value=\"".$page->title."\"/></td>\n";
            // Page theme
            echo "<td>";
			echo "<select name=\"frmPage".$page->page_id."Theme\">\n";
			foreach ($themes as $theme)
			{
				echo "<option value=\"".$theme."\" ";
				if ($theme==$page->theme)
					echo "selected";
				echo ">".$theme."</option>\n";
			}
			echo "</select>\n";
            echo "</td>\n";
            // End page theme
	        // Parent page in the menu
	        echo "<td><select name=\"frmPage".$page->page_id."ParentId\">\n";
	        echo "<option value=\"-1\" selected>".$this->T_("Root")."</option>\n";
    	    foreach ($pages as $parent_page)
	        {
	        	// Make sure we don't let users define a page as its own parent
	        	if ($parent_page->page_id != $page->page_id)
	        	{
		            echo "<option value=\"".$parent_page->page_id."\" ";
		            if ($page->parent_id == $parent_page->page_id)
		            	echo "selected";
		            echo ">".$parent_page->title."</option>\n";
		        }
	        }
	        echo "</select></td>\n";
	        // Change page order in the menu
	        echo "<td>";
	        $this->draw_action_link("<img src=\"modules/users/up.gif\" alt=\"".$this->T_("Up")."\" />","users","move_page_up",null,array("page_id" => $page->page_id));
	        $this->draw_action_link("<img src=\"modules/users/down.gif\" alt=\"".$this->T_("Down")."\" />","users","move_page_down",null,array("page_id" => $page->page_id));
	        if ($page->page_id != 0)
		        $this->draw_action_link("<img src=\"modules/users/delete.gif\" alt=\"".$this->T_("Delete")."\" />","users","process_delete_page",null,array("page_id" => $page->page_id));
	        echo "</td>\n";

            echo "</tr>\n";
            $i++;
        }
        echo "</table>\n";
		echo "<input type=\"hidden\" name=\"frmNumberOfPages\" value=\"".count($pages)."\" />\n";
        echo "<input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\" />";
        echo "</form>\n";

		echo "<h3>".$this->T_("Add page")."</h3>\n";
        // Add page form
		$this->draw_form_tag("users","process_add_page",null);
        echo "<table>\n";
        echo "<tr><td>".$this->T_("Page name")."</td><td><input type=\"text\" name=\"frmPageName\"></td></tr>\n";
		echo "<tr><td>".$this->T_("Page template")."</td><td><select name=\"frmPageTheme\">\n";
			foreach ($themes as $theme)
			{
				echo "<option value=\"".$theme."\">".$theme."</option>\n";
			}
		echo "</select>\n";
		echo "</td></tr>\n";
        echo "<tr><td>".$this->T_("Parent page in the menu")."</td><td><select name=\"frmPageParentId\">\n";
        echo "<option value=\"-1\" selected>".$this->T_("Root")."</option>\n";
        foreach ($pages as $page)
        {
            echo "<option value=\"".$page->page_id."\">".$page->title."</option>\n";
        }
        echo "</select>\n";
        echo "</td></tr>\n";
        // No page order here - always add at the end
        echo "</table>\n";
        echo "<input type=\"submit\" class=\"submit\" value=\"".$this->T_("Add")."\" />\n";
        echo "</form>\n";

        // End edit pages
	}
}

function display_site_settings()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		echo "<h3><img align=\"absmiddle\" src=\"modules/users/site_settings.gif\" alt=\"".$this->T_("Site settings")."\" />".$this->T_("Site settings")."</h3>\n";
		$this->draw_form_tag("users","process_general_config",null);
		echo "<table>\n";
		echo "<tr><td>".$this->T_("Site name").":</td><td><input type=\"text\" size=\"60\" name=\"frmPageTitle\" value=\"".stripslashes(XHP_C_PAGE_TITLE)."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Site URL").":</td><td><input type=\"text\" size=\"60\" name=\"frmPageUrl\" value=\"".XHP_C_PAGE_URL."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Site description").":</td><td><input type=\"text\" size=\"60\" name=\"frmPageDescription\" value=\"".stripslashes(XHP_C_PAGE_DESCRIPTION)."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Language").":</td><td>";
		// get list of available languages
		$dir = "languages";
		$languages = array();
		if (is_dir($dir))
		{
			if ($dh = opendir($dir))
			{
				while (($file = readdir($dh)) !== false)
					if (substr($file,0,5)=="lang-")
					{
						$language = substr($file,5);
						$index = strpos($language,"-");
						if ($index !== false)
							$language = substr($language,0,$index);
						$index = strpos($language,".");
						if ($index !== false)
							$language = substr($language,0,$index);
						if (!in_array($language,$languages))
							$languages[] = $language;
					}
				closedir($dh);
			}
		}
		$current_language = $db->get_var ("SELECT value FROM ".XHP_TBL_PREFIX."config WHERE variable='LANGUAGE' LIMIT 1");
		echo "<select name=\"frmLanguage\">\n";
		foreach ($languages as $language)
		{
			echo "  <option value=\"".$language."\" ";
			if ($current_language==$language)
			{
				echo " selected ";
			}
			echo ">".$language."</option>\n";
		}
		echo "</select>\n";
		echo "</td></tr>\n";
		echo "<tr><td colspan=\"2\"><input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\"/></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
}

function display_user_profile()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		$user = $db->get_row ("SELECT * FROM ".XHP_TBL_PREFIX."users WHERE username='".$db->quote($username)."'");
		echo "<h3><img align=\"absmiddle\" src=\"modules/users/user_profile.gif\" alt=\"".$this->T_("User profile")."\" />".$this->T_("User profile")."</h3>\n";
		$this->draw_form_tag("users","process_user_profile",null,array("user_id" => $user->id));
		echo "<table>\n";
		echo "<tr><td>".$this->T_("First name").":</td><td><input type=\"text\" size=\"60\" name=\"frmFirstName\" value=\"".stripslashes($user->first_name)."\"/></td></tr>\n";
		echo "<tr><td>".$this->T_("Last name").":</td><td><input type=\"text\" size=\"60\" name=\"frmLastName\" value=\"".stripslashes($user->last_name)."\"/></td></tr>\n";
		echo "<tr><td colspan=\"2\"><input type=\"submit\" class=\"submit\" value=\"".$this->T_("Update")."\"/></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}
}

function process_user_profile()
{
	// Output is not allowed here!!!!
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		if ($db->query ("UPDATE ".XHP_TBL_PREFIX."users SET first_name='".$db->quote($this->clean_post['frmFirstName'])."', last_name='".$db->quote($this->clean_post['frmLastName'])."' WHERE id='".$db->quote($this->clean_get['user_id'])."'") !== false)
		{
			// Action functions must return an error code that can be used
			// by display functions
			return 0;
		}
		else
		{
			return mysql_error();
		}
	}
	else
		return $this->T_("Not authorized");
}


function display_change_password()
{
	require_once ("config.php");
	global $db;
	if ($this->access_level >= XHP_ACCESS_ADMIN)
	{
		echo "<h3><img align=\"absmiddle\" src=\"modules/users/change_password.gif\" alt=\"".$this->T_("Change password")."\" />".$this->T_("Change password")."</h3>\n";
		$this->draw_form_tag("users","process_change_password",null);
		echo "<p>".$this->T_("New password").": <input type=\"text\" name=\"frmNewPassword\" /></p>\n";
		echo "<input type=\"submit\" class=\"submit\" value=\"".$this->T_("Change password")."\" />\n";
		echo "</form>\n";
	}
}

} // end class

function process_boxes($matches)
{
	// $matches[1] is the box name;
	$php_code = "<?php\ndraw_box (\"".$matches[1]."\");\n?>\n";
	return $php_code;
}

function process_links($matches)
{
	// Chech if the link is absolute
	global $theme_path;
	$link = $matches[1];
	$url_parts = parse_url($link);
	if (!isset($url_parts['scheme']))
	{
		// If no scheme we assume local URL
		$link = $theme_path."/".$link;
	}
	$link = str_replace($matches[1],$link,$matches[0]);
	return $link;
}
?>
